/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package generatestubs;

import org.mozilla.javascript.CompilerEnvirons;
import org.mozilla.javascript.ErrorReporter;
import org.mozilla.javascript.EvaluatorException;
import org.mozilla.javascript.ScriptOrFnNode;

/**
 *
 * @author tor
 */
public class Parser {
    public static boolean parse(String buffer, String filename, int lineno) {
        CompilerEnvirons compilerEnv = new CompilerEnvirons();
        final boolean error[] = new boolean[1];
        error[0] = false;
        ErrorReporter errorReporter =
            new ErrorReporter() {
                public void error(String message, String sourceName, int line,
                           String lineSource, int lineOffset) {
                    System.err.println("ERROR: " + message + ", sourceName=" + sourceName + ", line=" + line +", lineSource=" + lineSource);
                    error[0] = true;
                }

                public EvaluatorException runtimeError(String message, String sourceName,
                                                int line, String lineSource,
                                                int lineOffset) {
                    System.err.println("ERROR: " + message + ", sourceName=" + sourceName + ", line=" + line +", lineSource=" + lineSource);
                    error[0] = true;
                    return null;
                }

                public void warning(String message, String sourceName, int line,
                             String lineSource, int lineOffset) {
                    System.err.println("WARNING: " + message + ", sourceName=" + sourceName + ", line=" + line +", lineSource=" + lineSource);
                }
            };

        // XXX What do I set here: compilerEnv.setReservedKeywordAsIdentifier();

        org.mozilla.javascript.Context ctx = new org.mozilla.javascript.Context();
        compilerEnv.initFromContext(ctx);
        
        compilerEnv.setErrorReporter(errorReporter);
        compilerEnv.setGeneratingSource(false);
        compilerEnv.setGenerateDebugInfo(false);
        // We have a quickfix which lets you turn these warnings off or turn them
        // to errors
        compilerEnv.setReservedKeywordAsIdentifier(true);

        
        // The parser is NOT used for parsing here, but the Rhino scanner
        // calls into the parser for error messages. So we register our own error
        // handler for the parser and pass it into the tokenizer to handle errors.
        org.mozilla.javascript.Parser parser;
        parser = new org.mozilla.javascript.Parser(compilerEnv, errorReporter);

//        String fileName = "";
//
//        if ((context.file != null) && (context.file.getFileObject() != null)) {
//            fileName = context.file.getFileObject().getNameExt();
//        }

        try {
            ScriptOrFnNode root = parser.parse(buffer, filename, lineno);
        } catch (RuntimeException re) {
            //notifyError(context, message, sourceName, line, lineSource, lineOffset, sanitizing, Severity.WARNING, "", null);
            // XXX TODO - record this somehow
            error[0] = true;
        }

        return !error[0];
    }
}
