/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.jsstubsgenerator.stub;

import com.sun.org.apache.xpath.internal.axes.SelfIteratorNoPredicate;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Martin Fousek <marfous@netbeans.org>
 */
public class GeneratorUtils {

    public static List<StubObject> generateMethods(String[][] methods, String parent, boolean isStatic) {
        List<StubObject> methodStubs = new ArrayList<StubObject>();
        for (String[] method : methods) {
            StubObject methodStub = new StubObject(Origin.CORE, method[0], parent);
            methodStub.setPrune(true);
            methodStub.setType(Type.METHOD);
            methodStub.setStatic(isStatic);
            methodStub.setReturns(new Return(method[1], null));
            methodStub.setSummary(method[2]);
            methodStubs.add(methodStub);
        }
        return methodStubs;
    }

    public static List<StubObject> generateProperties(Origin origin, String[][] properties, String parent, boolean isStatic) {
        return generateProperties(origin, properties, parent, isStatic, true);
    }

    public static List<StubObject> generateProperties(Origin origin, String[][] properties, String parent, boolean isStatic, boolean prune) {
        List<StubObject> propertyStubs = new ArrayList<StubObject>();
        for (String[] property : properties) {
            StubObject propertyStub = new StubObject(origin, property[0], parent);
            propertyStub.setPrune(prune);
            propertyStub.setType(Type.PROPERTY);
            propertyStub.setStatic(isStatic);
            propertyStub.setReturns(new Return(property[1], null));
            propertyStub.setSummary(property[2]);
            propertyStubs.add(propertyStub);
        }
        return propertyStubs;
    }
}
