/*
 * PersistenceUtilsAbstractTest.java
 *
 * Created on March 23, 2007, 1:28 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.netbeans.modules.exceptions.web;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import junit.framework.TestCase;
import org.junit.Assert;
import org.junit.Test;
import org.netbeans.modules.exceptions.entity.Jarfile;
import org.netbeans.modules.exceptions.utils.PersistenceUtils;

/**
 *
 * @author pblaha
 */
public class PersistenceUtilsAbstractTest extends TestCase {
    
    static EntityManagerFactory emF = Persistence.createEntityManagerFactory("TestPU");
    PersistenceUtils persUtil;
    static boolean isDBInit = false ;
    
    /** Creates a new  of PersistenceUtilsAbstractTest
     * @throws java.lang.Exception
     */
    public PersistenceUtilsAbstractTest() throws Exception {
        PersistenceUtils.setDefault(PersistenceUtils.TEST_PU);
        persUtil = PersistenceUtils.getInstance();
        // initialized embedde database only once. It seems that BeforeClass annotation doesn't work :-(
        // This one is only workaround !!!!
        if(!isDBInit) {
            setupDatabase();
            isDBInit = true;
        }
    }
    
    /**
     *
     */
    @Test
    public void testMustang() {
        // JavaDB is included only in Mustang
        // check java version.
        Assert.assertTrue("Tests require jdk 1.6.0", System.getProperty("java.version").startsWith("1.6.0"));
    }
    
    
    
    static void setupDatabase() throws Exception {
        EntityManager em = emF.createEntityManager();
        em.getTransaction().begin();
        try{
            
            // create new JarFile
            Jarfile file1 = new Jarfile();
            file1.setId(1);
            file1.setName("org-ntebanes.jar");
            em.persist(file1);
            
            
            em.getTransaction().commit();;
        } catch(Exception ex) {
            em.getTransaction().rollback();
            throw ex;
        }
        
    }
    
    
}
