#!/bin/bash
if [ -n "$1" ]; then
    OUTPUT_FILE="$1.sql"
    echo "Migrating $1 to $OUTPUT_FILE"
else
    echo "You need to specify correct mapping file"
    exit 1
fi

#clean outputfile
echo > $OUTPUT_FILE

echo "DELIMITER //">> $OUTPUT_FILE
echo "DROP PROCEDURE IF EXISTS migrate_components;" >> $OUTPUT_FILE
echo "CREATE PROCEDURE migrate_components()" >> $OUTPUT_FILE
echo "BEGIN" >> $OUTPUT_FILE
echo "DECLARE comp VARCHAR(100);" >> $OUTPUT_FILE
echo "DECLARE subcomp VARCHAR(100);" >> $OUTPUT_FILE

cat "$1" |while read line
do
    if [ -z "$line" ]; then
        continue;
    fi;
    jar_name=`echo "$line" |cut -d: -f1`
    component=`echo "$line" |cut -d: -f2`
    subcomponent=`echo "$line" |cut -d: -f3`
    echo "SET comp = NULL;" >> $OUTPUT_FILE
    echo "SET subcomp = NULL;" >> $OUTPUT_FILE
    echo "SELECT COMPONENT,SUBCOMPONENT INTO comp,subcomp FROM sourcejar_mapping WHERE SOURCEJAR='$jar_name';" >> $OUTPUT_FILE
    echo "IF (comp IS NULL) THEN" >> $OUTPUT_FILE
    echo "   INSERT INTO sourcejar_mapping VALUES ('$jar_name', '$component', '$subcomponent');" >> $OUTPUT_FILE
    echo "   SELECT '$jar_name' AS 'INSERTED';" >> $OUTPUT_FILE
    echo "ELSEIF ('$component' = comp AND '$subcomponent' = subcomp ) THEN " >> $OUTPUT_FILE
    echo "   SELECT '$jar_name' AS 'ALREADY OK';" >> $OUTPUT_FILE
    echo "ELSE" >> $OUTPUT_FILE
    echo "   SELECT '$jar_name', comp, subcomp, '$component', '$subcomponent' AS 'COLLISION', 'OLD_COMP', 'OLD_SUBCOMP', 'NEW_COMP', 'NEW_SUBCOMP';" >> $OUTPUT_FILE
    echo "END IF;" >> $OUTPUT_FILE
done

echo "END // " >> $OUTPUT_FILE
echo "DELIMITER ;"  >> $OUTPUT_FILE
echo "" >> $OUTPUT_FILE
echo "CALL migrate_components();" >> $OUTPUT_FILE


echo "DONE"