/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2009 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package org.netbeans.test.uihandler.selenium;

/**
 *
 * @author Jindrich Sedek
 */
public class NbFeedbackTest extends SeleniumTestBase {

    public void testFeedbackByUserName() throws Exception {
        selenium.open("analytics/nbfeedback.do?userName=exceptions");
        verifyCorrect("1", "java.lang.NullPointerException: TESTING");

        selenium.open("analytics/nbfeedback.do?userName=exceptions");
        verifyCorrect("8", "java.lang.OutOfMemoryError: Java heap space");

        selenium.open("analytics/nbfeedback.do?userName=exceptions");
        verifyCorrect("5", "java.lang.NullPointerException: TESTING");
    }

    public void testFeedbackByUserId() throws Exception {
        selenium.open("analytics/nbfeedback.do?userId=NB_CND_JAVA_RUBY_TOMCAT_UML_WEBEE002ed73c3-cf3c-43d9-a76e-3455a6704fd4");
        verifyCorrect("16258", "NullPointerException at javax.swing.JComponent._paintImmediately");

        selenium.open("analytics/nbfeedback.do?userId=NB_CND_JAVA_RUBY_TOMCAT_UML_WEBEE002ed73c3-cf3c-43d9-a76e-3455a6704fd4");
        verifyCorrect("44316", "NoClassDefFoundError: org/netbeans/modules/cnd/loaders/HDataObject");

        selenium.open("analytics/nbfeedback.do?userId=NB_CND_JAVA_RUBY_TOMCAT_UML_WEBEE002ed73c3-cf3c-43d9-a76e-3455a6704fd4");
        verifyCorrect("17029", "reflect.UndeclaredThrowableException at $Proxy9.propertyChange");
    }

    void verifyCorrect(String excID, String message) {
        verifyTrue(selenium.isTextPresent(message));
        selenium.click("link=" + excID);
        selenium.waitForPageToLoad("30000");
        verifyTrue(selenium.isTextPresent("Exception #" + excID));
        verifyTrue(selenium.isTextPresent(message));
    }
}
