/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.server.uihandler.statistics;

import org.netbeans.junit.NbTestCase;
import org.netbeans.server.uihandler.statistics.ParsingStatistics.Counts;

public class ParsingStatisticsTest extends NbTestCase {
    
    public ParsingStatisticsTest(String s) {
        super(s);
    }

    public void testJoinMaximum() {
        Counts a = Counts.createEvent(30);
        Counts b = Counts.createEvent(50);
        Counts r = Counts.join(a, b);
        assertEquals(50, r.when);        
    }

    public void testIdletime() {
        Counts a = Counts.createEvent(30);
        Counts b = Counts.started(100080, 100000);
        Counts r = Counts.join(a, b);
        assertEquals(100080, r.when);        
        assertEquals("Idle time", 100050, r.idle);
        assertEquals("No parsing", 0, r.indexing);
        assertEquals("was ready for 100s", 100000, r.ready);
        assertEquals("Not waiting", 0, r.waiting);
    }
    public void testParsingTime() {
        Counts a = Counts.createEvent(30);
        Counts b = Counts.finished(80, 100000);
        Counts r = Counts.join(a, b);
        assertEquals(80, r.when);        
        assertEquals("No Idle time", 0, r.idle);
        assertEquals("Parsing", 100000, r.indexing);
        assertEquals("Not ready", 0, r.ready);
        assertEquals("Not waiting", 0, r.waiting);
    }
    public void testRealDataPlusIdle() {
        Counts a = new Counts(10, 20, 30, 40, 50);
        Counts b = Counts.finished(30100, 100000);
        Counts sum = Counts.join(a, b);
        assertEquals("Parsing time ++", 20, sum.ready);
        assertEquals("Parsing time ++", 100010, sum.indexing);
        assertEquals("Waiting time 20", 30120, sum.waiting);
        assertEquals("When is a max", 30100, sum.when);
        assertEquals("Idle copied from a", 40, sum.idle);
    }
}
