/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2008 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2008 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package org.netbeans.examples.cards.api;

import org.openide.util.NbBundle;

/**
 *
 * @author Tim Boudreau
 */
public enum Rank {

    ACE, TWO, THREE, FOUR, FIVE,
    SIX, SEVEN, EIGHT, NINE, TEN,
    JACK, QUEEN, KING, JOKER;

    String imageNameInfix() {
        String result;
        switch (this) {
            case ACE:
                result = "a";
                break;
            case TWO:
                result = "2";
                break;
            case THREE:
                result = "3";
                break;
            case FOUR:
                result = "4";
                break;
            case FIVE:
                result = "5";
                break;
            case SIX:
                result = "6";
                break;
            case SEVEN:
                result = "7";
                break;
            case EIGHT:
                result = "8";
                break;
            case NINE:
                result = "9";
                break;
            case TEN:
                result = "10";
                break;
            case JACK:
                result = "j";
                break;
            case QUEEN:
                result = "q";
                break;
            case KING:
                result = "k";
                break;
            case JOKER:
                result = "joker-r";
                break;
            default:
                throw new AssertionError();
        }
        return result;
    }

    @Override
    public String toString() {
        String key;
        switch (this) {
            case ACE:
                key = "ACE";
                break;
            case TWO:
                key = "TWO";
                break;
            case THREE:
                key = "THREE";
                break;
            case FOUR:
                key = "FOUR";
                break;
            case FIVE:
                key = "FIVE";
                break;
            case SIX:
                key = "SIX";
                break;
            case SEVEN:
                key = "SEVEN";
                break;
            case EIGHT:
                key = "EIGHT";
                break;
            case NINE:
                key = "NINE";
                break;
            case TEN:
                key = "TEN";
                break;
            case JACK:
                key = "JACK";
                break;
            case QUEEN:
                key = "QUEEN";
                break;
            case KING:
                key = "KING";
                break;
            case JOKER:
                key = "JOKER";
                break;
            default:
                throw new AssertionError();
        }
        return NbBundle.getMessage(Rank.class, key);
    }
}
