package org.netbeans.modules.myfirstpalette.palette;

import java.io.IOException;
import org.openide.filesystems.FileObject;
import org.openide.loaders.DataObjectExistsException;
import org.openide.loaders.MultiDataObject;
import org.openide.loaders.UniFileLoader;
import org.openide.util.NbBundle;

public class CardDataLoader extends UniFileLoader {
    
    public static final String REQUIRED_MIME = "text/x-myitem";
    
    private static final long serialVersionUID = 1L;
    
    public CardDataLoader() {
        super("org.netbeans.modules.myfirstpalette.palette.CardDataObject");
    }
    
    protected String defaultDisplayName() {
        return NbBundle.getMessage(CardDataLoader.class, "LBL_Card_loader_name");
    }
    
    protected void initialize() {
        super.initialize();
        getExtensions().addMimeType(REQUIRED_MIME);
    }
    
    protected MultiDataObject createMultiObject(FileObject primaryFile) throws DataObjectExistsException, IOException {
        return new CardDataObject(primaryFile, this);
    }
    
    protected String actionsContext() {
        return "Loaders/" + REQUIRED_MIME + "/Actions";
    }
    
}
