/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2008 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2008 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package org.netbeans.examples.nbtidyintegration;

import java.io.File;
import java.util.prefs.Preferences;
import javax.swing.JFileChooser;
import org.openide.util.NbBundle;

final class TidyConfigurationPanel extends javax.swing.JPanel {


    //not used private final TidyConfigurationOptionsPanelController controller;
    TidyConfigurationPanel(TidyConfigurationOptionsPanelController controller) {
        // this.controller = controller;
        initComponents();
    // TODO listen to changes in form fields and call controller.changed()
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        executableLabel = new javax.swing.JLabel();
        executableTextField = new javax.swing.JTextField();
        executableBrowseButton = new javax.swing.JButton();

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jTextArea1.setText("The Tidy-ecutable must be downloaded and installed separatly. Please goto http://tidy.sourceforge.net/\n");
        jScrollPane1.setViewportView(jTextArea1);

        setBackground(java.awt.Color.white);
        org.openide.awt.Mnemonics.setLocalizedText(executableLabel, "Tidy Executable:");
        executableLabel.setToolTipText("The Tidy-ecutable must be downloaded and installed separatly. Please goto http://tidy.sourceforge.net/");

        executableTextField.setText("Select Path");
        executableTextField.setToolTipText("The Tidy-ecutable must be downloaded and installed separatly. Please goto http://tidy.sourceforge.net/");

        org.openide.awt.Mnemonics.setLocalizedText(executableBrowseButton, "Browse ...");
        executableBrowseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                executableBrowseButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(executableLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 80, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(executableTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 498, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(executableBrowseButton)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(executableBrowseButton)
                    .add(executableLabel)
                    .add(executableTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void executableBrowseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_executableBrowseButtonActionPerformed
        String filename = executableTextField.getText();
        JFileChooser chooser = new JFileChooser(new File(filename));

        // Show open dialog; this method does not return until the dialog is closed
        int result = chooser.showOpenDialog(this);

        // Determine which button was clicked to close the dialog
        switch (result) {
            case JFileChooser.APPROVE_OPTION:
                File selectedFile = chooser.getSelectedFile();
                executableTextField.setText(selectedFile.getAbsolutePath());
                break;
            case JFileChooser.CANCEL_OPTION:
                // Cancel or the close-dialog icon was clicked
                break;
            case JFileChooser.ERROR_OPTION:
                // The selection process did not complete successfully
                break;
        }
    }//GEN-LAST:event_executableBrowseButtonActionPerformed

    void load() {
        String defaultValue = NbBundle.getMessage(TidyErrorCheckAction.class, "AdvancedOption_Executable_Path_Default");
        executableTextField.setText(Preferences.userNodeForPackage(TidyConfigurationPanel.class).get(TidyRunnable.EXECUTABLE_KEY, defaultValue));
    // or:
    // someTextField.setText(SomeSystemOption.getDefault().getSomeStringProperty());
    }

    void store() {
        Preferences.userNodeForPackage(TidyConfigurationPanel.class).put(TidyRunnable.EXECUTABLE_KEY, executableTextField.getText());
    // or:
    // SomeSystemOption.getDefault().setSomeStringProperty(someTextField.getText());
    }

    /** check whether form is consistent and complete*/
    boolean valid() {
        String path = executableTextField.getText();
        return new File(path).exists();
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton executableBrowseButton;
    private javax.swing.JLabel executableLabel;
    private javax.swing.JTextField executableTextField;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    // End of variables declaration//GEN-END:variables
}
