/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2008 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2008 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package org.netbeans.examples.nbtidyintegration;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JPanel;
import javax.swing.SpinnerNumberModel;
import org.openide.util.NbBundle;

public final class TidyConvertVisualPanel1 extends JPanel {

    private DefaultComboBoxModel encodingModel = null;
    private SpinnerNumberModel spinnerModel = null;
    private DefaultComboBoxModel formatOutputModel = null;

    /** Creates new form NBTidyConversionVisualPanel2 */
    public TidyConvertVisualPanel1() {
        initComponents();
    }

    /**
     *
     * @return
     */
    public String getName() {
        return NbBundle.getMessage(getClass(), "CTL_TidyConversionWizardStep1");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents()
    {

        formatOutputButtonGroup = new javax.swing.ButtonGroup();
        indentCheckBox = new javax.swing.JCheckBox();
        wrapLineCheckBox = new javax.swing.JCheckBox();
        wrapLineTextField = new javax.swing.JTextField();
        cleanCheckBox = new javax.swing.JCheckBox();
        bareCheckBox = new javax.swing.JCheckBox();
        numericCheckBox = new javax.swing.JCheckBox();
        omitCheckBox = new javax.swing.JCheckBox();
        cleanLabel = new javax.swing.JLabel();
        bareLabel = new javax.swing.JLabel();
        numericLabel = new javax.swing.JLabel();
        omitLabel = new javax.swing.JLabel();
        xmlCheckBox = new javax.swing.JCheckBox();
        xmlLabel = new javax.swing.JLabel();
        accessCheckLevelLabel = new javax.swing.JLabel();
        formatOutputLabel = new javax.swing.JLabel();
        encodingLabel = new javax.swing.JLabel();
        encodingComboBox = new javax.swing.JComboBox();
        accessCheckLevelSpinner = new javax.swing.JSpinner();
        encodingValueLabel = new javax.swing.JLabel();
        indentLabel = new javax.swing.JLabel();
        upperLabel = new javax.swing.JLabel();
        upperCheckBox = new javax.swing.JCheckBox();
        formatOutputComboBox = new javax.swing.JComboBox();
        formatOutputValueLabel = new javax.swing.JLabel();
        wrapColumnLabel = new javax.swing.JLabel();
        setDefaultValuesButton = new javax.swing.JButton();

        org.openide.awt.Mnemonics.setLocalizedText(indentCheckBox, "Indent");
        indentCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        indentCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.openide.awt.Mnemonics.setLocalizedText(wrapLineCheckBox, "Wrap line");
        wrapLineCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        wrapLineCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));
        wrapLineCheckBox.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                wrapLineCheckBoxItemStateChanged(evt);
            }
        });

        wrapLineTextField.setText("80");

        org.openide.awt.Mnemonics.setLocalizedText(cleanCheckBox, "Clean");
        cleanCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        cleanCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.openide.awt.Mnemonics.setLocalizedText(bareCheckBox, "Bare");
        bareCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        bareCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.openide.awt.Mnemonics.setLocalizedText(numericCheckBox, "Numeric");
        numericCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        numericCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.openide.awt.Mnemonics.setLocalizedText(omitCheckBox, "Omit");
        omitCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        omitCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.openide.awt.Mnemonics.setLocalizedText(cleanLabel, "replace FONT, NOBR and CENTER tags by CSS");

        org.openide.awt.Mnemonics.setLocalizedText(bareLabel, "strip out smart quotes and em dashes, etc.");

        org.openide.awt.Mnemonics.setLocalizedText(numericLabel, "output numeric rather than named entities");

        org.openide.awt.Mnemonics.setLocalizedText(omitLabel, "omit optional end tags");

        org.openide.awt.Mnemonics.setLocalizedText(xmlCheckBox, "XML");
        xmlCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        xmlCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.openide.awt.Mnemonics.setLocalizedText(xmlLabel, "specify the input is well formed XML");

        org.openide.awt.Mnemonics.setLocalizedText(accessCheckLevelLabel, "Access Check Level:");

        org.openide.awt.Mnemonics.setLocalizedText(formatOutputLabel, "FormatOutput :");

        org.openide.awt.Mnemonics.setLocalizedText(encodingLabel, "Encoding:");

        encodingComboBox.setModel(getEncodingComboBoxModel());
        encodingComboBox.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                encodingComboBoxItemStateChanged(evt);
            }
        });
        encodingComboBox.addPropertyChangeListener(new java.beans.PropertyChangeListener()
        {
            public void propertyChange(java.beans.PropertyChangeEvent evt)
            {
                encodingComboBoxPropertyChange(evt);
            }
        });

        accessCheckLevelSpinner.setModel(getAccessCheckLevelModel());

        org.openide.awt.Mnemonics.setLocalizedText(encodingValueLabel, "specify encoding");

        org.openide.awt.Mnemonics.setLocalizedText(indentLabel, "indent content");

        org.openide.awt.Mnemonics.setLocalizedText(upperLabel, "force tags to upper case");

        org.openide.awt.Mnemonics.setLocalizedText(upperCheckBox, "Upper");
        upperCheckBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        upperCheckBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        formatOutputComboBox.setModel(getFormatOutputComboBoxModel());
        formatOutputComboBox.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                formatOutputComboBoxItemStateChanged(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(formatOutputValueLabel, "specify output format");

        org.openide.awt.Mnemonics.setLocalizedText(wrapColumnLabel, "Column:");

        org.openide.awt.Mnemonics.setLocalizedText(setDefaultValuesButton, "Reset to Defaults");
        setDefaultValuesButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                setDefaultValuesButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(xmlCheckBox)
                        .add(51, 51, 51)
                        .add(xmlLabel))
                    .add(layout.createSequentialGroup()
                        .add(accessCheckLevelLabel)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(accessCheckLevelSpinner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(formatOutputLabel)
                            .add(encodingLabel)
                            .add(omitCheckBox)
                            .add(numericCheckBox)
                            .add(bareCheckBox)
                            .add(cleanCheckBox)
                            .add(upperCheckBox)
                            .add(indentCheckBox)
                            .add(wrapLineCheckBox))
                        .add(20, 20, 20)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(omitLabel)
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                .add(layout.createSequentialGroup()
                                    .add(wrapColumnLabel)
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                    .add(wrapLineTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 50, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .add(indentLabel)
                                .add(bareLabel)
                                .add(upperLabel)
                                .add(cleanLabel)
                                .add(layout.createSequentialGroup()
                                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                        .add(formatOutputComboBox, 0, 125, Short.MAX_VALUE)
                                        .add(org.jdesktop.layout.GroupLayout.TRAILING, encodingComboBox, 0, 125, Short.MAX_VALUE))
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                        .add(layout.createSequentialGroup()
                                            .add(encodingValueLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .add(25, 25, 25))
                                        .add(formatOutputValueLabel)))
                                .add(numericLabel)))))
                .add(89, 89, 89)
                .add(setDefaultValuesButton)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(xmlCheckBox)
                    .add(xmlLabel))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(accessCheckLevelLabel)
                    .add(accessCheckLevelSpinner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(encodingLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 17, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(encodingValueLabel)
                    .add(encodingComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(formatOutputLabel)
                    .add(formatOutputValueLabel)
                    .add(formatOutputComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(wrapColumnLabel)
                    .add(wrapLineTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(wrapLineCheckBox))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(indentLabel)
                    .add(indentCheckBox))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(upperLabel)
                    .add(upperCheckBox))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(cleanLabel)
                    .add(cleanCheckBox))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(bareLabel)
                    .add(bareCheckBox))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(numericLabel)
                    .add(numericCheckBox))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(setDefaultValuesButton)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(omitLabel)
                        .add(omitCheckBox)))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void setDefaultValuesButtonActionPerformed (java.awt.event.ActionEvent evt)//GEN-FIRST:event_setDefaultValuesButtonActionPerformed
    {//GEN-HEADEREND:event_setDefaultValuesButtonActionPerformed

        setEncoding(TidySettings.DEFAULT_CONVERSION_ENCODING);
        setIndent(TidySettings.DEFAULT_CONVERSION_INDENT);
        setClean(TidySettings.DEFAULT_CONVERSION_CLEAN);
        setBare(TidySettings.DEFAULT_CONVERSION_BARE);
        setUpper(TidySettings.DEFAULT_CONVERSION_UPPER);
        setNumeric(TidySettings.DEFAULT_CONVERSION_NUMERIC);
        setOmit(TidySettings.DEFAULT_CONVERSION_OMIT);
        setXML(TidySettings.DEFAULT_CONVERSION_XML);
        setWrap(TidySettings.DEFAULT_CONVERSION_WRAP, TidySettings.DEFAULT_CONVERSION_WRAP_COLUMN);
        setAccessCheckLevel(TidySettings.DEFAULT_CONVERSION_ACCESS_CHECK_LEVEL);


        setFormatOutput(TidySettings.DEFAULT_CONVERSION_FORMAT_OUTPUT);

    }//GEN-LAST:event_setDefaultValuesButtonActionPerformed

    private void wrapLineCheckBoxItemStateChanged (java.awt.event.ItemEvent evt)//GEN-FIRST:event_wrapLineCheckBoxItemStateChanged
    {//GEN-HEADEREND:event_wrapLineCheckBoxItemStateChanged
        wrapLineTextField.setEnabled(wrapLineCheckBox.isSelected());
    }//GEN-LAST:event_wrapLineCheckBoxItemStateChanged

    private void formatOutputComboBoxItemStateChanged (java.awt.event.ItemEvent evt)//GEN-FIRST:event_formatOutputComboBoxItemStateChanged
    {//GEN-HEADEREND:event_formatOutputComboBoxItemStateChanged
    }//GEN-LAST:event_formatOutputComboBoxItemStateChanged

    private void encodingComboBoxItemStateChanged (java.awt.event.ItemEvent evt)//GEN-FIRST:event_encodingComboBoxItemStateChanged
    {//GEN-HEADEREND:event_encodingComboBoxItemStateChanged
        encodingValueLabel.setText((String) encodingComboBox.getSelectedItem());
    }//GEN-LAST:event_encodingComboBoxItemStateChanged

    private void encodingComboBoxPropertyChange (java.beans.PropertyChangeEvent evt)//GEN-FIRST:event_encodingComboBoxPropertyChange
    {//GEN-HEADEREND:event_encodingComboBoxPropertyChange
        encodingValueLabel.setText((String) encodingComboBox.getSelectedItem());
    }//GEN-LAST:event_encodingComboBoxPropertyChange
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel accessCheckLevelLabel;
    private javax.swing.JSpinner accessCheckLevelSpinner;
    private javax.swing.JCheckBox bareCheckBox;
    private javax.swing.JLabel bareLabel;
    private javax.swing.JCheckBox cleanCheckBox;
    private javax.swing.JLabel cleanLabel;
    private javax.swing.JComboBox encodingComboBox;
    private javax.swing.JLabel encodingLabel;
    private javax.swing.JLabel encodingValueLabel;
    private javax.swing.ButtonGroup formatOutputButtonGroup;
    private javax.swing.JComboBox formatOutputComboBox;
    private javax.swing.JLabel formatOutputLabel;
    private javax.swing.JLabel formatOutputValueLabel;
    private javax.swing.JCheckBox indentCheckBox;
    private javax.swing.JLabel indentLabel;
    private javax.swing.JCheckBox numericCheckBox;
    private javax.swing.JLabel numericLabel;
    private javax.swing.JCheckBox omitCheckBox;
    private javax.swing.JLabel omitLabel;
    private javax.swing.JButton setDefaultValuesButton;
    private javax.swing.JCheckBox upperCheckBox;
    private javax.swing.JLabel upperLabel;
    private javax.swing.JLabel wrapColumnLabel;
    private javax.swing.JCheckBox wrapLineCheckBox;
    private javax.swing.JTextField wrapLineTextField;
    private javax.swing.JCheckBox xmlCheckBox;
    private javax.swing.JLabel xmlLabel;
    // End of variables declaration//GEN-END:variables

    private DefaultComboBoxModel getEncodingComboBoxModel() {
        if (encodingModel == null) {
            encodingModel = new DefaultComboBoxModel(TidySettings.getEncodings());

        }
        return encodingModel;
    }

    private SpinnerNumberModel getAccessCheckLevelModel() {
        if (spinnerModel == null) {
            spinnerModel = new SpinnerNumberModel();
            spinnerModel.setMinimum(Integer.valueOf(0));
            spinnerModel.setMaximum(Integer.valueOf(4));
        }
        return spinnerModel;
    }

    private DefaultComboBoxModel getFormatOutputComboBoxModel() {
        if (formatOutputModel == null) {
            formatOutputModel = new DefaultComboBoxModel(TidySettings.getFormatOutputOptions());
        }
        return formatOutputModel;
    }

    public void setEncoding(String value) {
        encodingComboBox.getModel().setSelectedItem(value);
    }

    public void setIndent(boolean value) {
        indentCheckBox.setSelected(value);
    }

    public void setClean(boolean value) {
        cleanCheckBox.setSelected(value);
    }

    public void setBare(boolean value) {
        bareCheckBox.setSelected(value);
    }

    public void setUpper(boolean value) {
        upperCheckBox.setSelected(value);

    }

    public void setNumeric(boolean value) {
        numericCheckBox.setSelected(value);
    }

    public void setOmit(boolean value) {
        omitCheckBox.setSelected(value);
    }

    public void setXML(boolean value) {
        xmlCheckBox.setSelected(value);
    }

    public void setWrap(boolean wrap, Integer value) {
        wrapLineCheckBox.setSelected(wrap);
        wrapLineTextField.setText(value.toString());
        wrapLineTextField.setEnabled(wrap);
    }

    public void setAccessCheckLevel(int value) {
        getAccessCheckLevelModel().setValue(value);
    }

    public void setFormatOutput(String value) {

        formatOutputComboBox.getModel().setSelectedItem(value);
    }

    /**
     * Read Tidy Setting from widget
     * @return
     */
    public boolean getWrapLine() {
        return wrapLineCheckBox.isSelected();
    }

    /**
     * Read Tidy Setting from widget
     * @return
     */
    public int getWrapLineColumn() {
        return Integer.parseInt(wrapLineTextField.getText());
    }

    /**
     * Read Tidy Setting from widget
     * @return
     */
    public int getAccessCheckLevel() {
        return Integer.parseInt(getAccessCheckLevelModel().getValue().toString());
    }

    /**
     * Read Tidy Setting from widget
     * @return
     */
    public boolean getBare() {
        return bareCheckBox.isSelected();
    }

    /**
     * Read Tidy Setting from widget
     * @return
     */
    public boolean getClean() {
        return cleanCheckBox.isSelected();
    }

    /**
     * Read Tidy Setting from widget
     * @return
     */
    public String getEncoding() {
        return encodingComboBox.getModel().getSelectedItem().toString();
    }

    /**
     * Read Tidy Setting from widget
     * @return
     */
    public String getFormatOutput() {
        return formatOutputComboBox.getModel().getSelectedItem().toString();
    }

    /**
     * Read Tidy Setting from widget
     * @return
     */
    public boolean getIndent() {
        return indentCheckBox.isSelected();
    }

    /**
     * Read Tidy Setting from widget
     * @return
     */
    public boolean getNumeric() {
        return numericCheckBox.isSelected();
    }

    /**
     * Read Tidy Setting from widget
     * @return
     */
    public boolean getOmit() {
        return omitCheckBox.isSelected();
    }

    /**
     * Read Tidy Setting from widget
     * @return
     */
    public boolean getUpper() {
        return upperCheckBox.isSelected();
    }

    /**
     * Read Tidy Setting from widget
     * @return
     */
    public boolean getXML() {
        return xmlCheckBox.isSelected();
    }
}


