/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/

package org.netbeans.pluginportal.ui;

import java.util.Date;

/**
 * This class is used as a scaled down type representing a Plugin and solely for 
 * for the purpose of displaying values.
 * @author David Botterill
 */
public class PluginDetail {
    
    /** Creates a new instance of PluginDetail */
    public PluginDetail() {
    }

    /**
     * Holds value of property name.
     */
    private String name;

    /**
     * Getter for property name.
     * @return Value of property name.
     */
    public String getName() {
        return this.name;
    }

    /**
     * Setter for property name.
     * @param name New value of property name.
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Holds value of property image_url.
     */
    private String image_url;

    /**
     * Getter for property image_name.
     * @return Value of property image_name.
     */
    public String getImage_url() {
        return this.image_url;
    }

    /**
     * Setter for property image_name.
     * @param image_url New value of property image_name.
     */
    public void setImage_url(String image_url) {
        this.image_url = image_url;
    }

    /**
     * Holds value of property rating.
     */
    private double rating;

    /**
     * Getter for property rating.
     * @return Value of property rating.
     */
    public double getRating() {
        return this.rating;
    }

    /**
     * Setter for property rating.
     * @param rating New value of property rating.
     */
    public void setRating(double rating) {
        this.rating = rating;
    }

    /**
     * Holds value of property author.
     */
    private String author;

    /**
     * Getter for property author.
     * @return Value of property author.
     */
    public String getAuthor() {
        return this.author;
    }

    /**
     * Setter for property author.
     * @param author New value of property author.
     */
    public void setAuthor(String author) {
        this.author = author;
    }

    /**
     * Holds value of property downloads.
     */
    private String downloads;

    /**
     * Getter for property downloads.
     * @return Value of property downloads.
     */
    public String getDownloads() {
        return this.downloads;
    }

    /**
     * Setter for property downloads.
     * @param downloads New value of property downloads.
     */
    public void setDownloads(String downloads) {
        this.downloads = downloads;
    }

    /**
     * Holds value of property total_raters.
     */
    private Integer total_raters;

    /**
     * Getter for property total_raters.
     * @return Value of property total_raters.
     */
    public Integer getTotal_raters() {
        return this.total_raters;
    }

    /**
     * Setter for property total_raters.
     * @param total_raters New value of property total_raters.
     */
    public void setTotal_raters(Integer total_raters) {
        this.total_raters = total_raters;
    }

    /**
     * Holds value of property quality_level.
     */
    private String quality_level;

    /**
     * Getter for property quality_level.
     * @return Value of property quality_level.
     */
    public String getQuality_level() {
        return this.quality_level;
    }

    /**
     * Setter for property quality_level.
     * @param quality_level New value of property quality_level.
     */
    public void setQuality_level(String quality_level) {
        this.quality_level = quality_level;
    }

    /**
     * Holds value of property categories.
     */
    private String categories;

    /**
     * Getter for property categories.
     * @return Value of property categories.
     */
    public String getCategories() {
        return this.categories;
    }

    /**
     * Setter for property categories.
     * @param categories New value of property categories.
     */
    public void setCategories(String categories) {
        this.categories = categories;
    }

    /**
     * Holds value of property summary.
     */
    private String summary;

    /**
     * Getter for property summary.
     * @return Value of property summary.
     */
    public String getSummary() {
        return this.summary;
    }

    /**
     * Setter for property summary.
     * @param summary New value of property summary.
     */
    public void setSummary(String summary) {
        this.summary = summary;
    }

    /**
     * Holds value of property pluginid.
     */
    private Long pluginid;

    /**
     * Getter for property pluginid.
     * @return Value of property pluginid.
     */
    public Long getPluginid() {
        return this.pluginid;
    }

    /**
     * Setter for property pluginid.
     * @param pluginid New value of property pluginid.
     */
    public void setPluginid(Long pluginid) {
        this.pluginid = pluginid;
    }

    /**
     * Holds value of property display_category.
     */
    private String display_category;

    /**
     * Getter for property display_category.
     * @return Value of property display_category.
     */
    public String getDisplay_category() {
        return this.display_category;
    }

    /**
     * Setter for property display_category.
     * @param display_category New value of property display_category.
     */
    public void setDisplay_category(String display_category) {
        this.display_category = display_category;
    }

    /**
     * Holds value of property avgRatingText.
     */
    private String avgRatingText;

    /**
     * Getter for property avgRatingText.
     * @return Value of property avgRatingText.
     */
    public String getAvgRatingText() {
        return this.avgRatingText;
    }

    /**
     * Setter for property avgRatingText.
     * @param avgRatingText New value of property avgRatingText.
     */
    public void setAvgRatingText(String avgRatingText) {
        this.avgRatingText = avgRatingText;
    }

    /**
     * Holds value of property date_added.
     */
    private Date date_added;

    /**
     * Getter for property date_added.
     * @return Value of property date_added.
     */
    public Date getDate_added() {
        return this.date_added;
    }

    /**
     * Setter for property date_added.
     * @param date_added New value of property date_added.
     */
    public void setDate_added(Date date_added) {
        this.date_added = date_added;
    }

    /**
     * Holds value of property version.
     */
    private String version;

    /**
     * Getter for property version.
     * @return Value of property version.
     */
    public String getVersion() {
        return this.version;
    }

    /**
     * Setter for property version.
     * @param version New value of property version.
     */
    public void setVersion(String version) {
        this.version = version;
    }

    /**
     * Holds value of property date_updated.
     */
    private Date date_updated;

    /**
     * Getter for property date_updated.
     * @return Value of property date_updated.
     */
    public Date getDate_updated() {
        return this.date_updated;
    }

    /**
     * Setter for property date_updated.
     * @param date_updated New value of property date_updated.
     */
    public void setDate_updated(Date date_updated) {
        this.date_updated = date_updated;
    }

    /**
     * Holds value of property url.
     */
    private String url;

    /**
     * Getter for property url.
     * @return Value of property url.
     */
    public String getUrl() {
        return this.url;
    }

    /**
     * Setter for property url.
     * @param url New value of property url.
     */
    public void setUrl(String url) {
        this.url = url;
    }

    /**
     * Holds value of property ownerUrl.
     */
    private String ownerUrl;

    /**
     * Getter for property ownerURL.
     * @return Value of property ownerURL.
     */
    public String getOwnerUrl() {
        return this.ownerUrl;
    }

    /**
     * Setter for property ownerURL.
     * @param ownerURL New value of property ownerURL.
     */
    public void setOwnerUrl(String ownerUrl) {
        this.ownerUrl = ownerUrl;
    }
    
}
