/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/
package pluginportal;

import com.sun.data.provider.RowKey;
import com.sun.j2ee.blueprints.ui.rating.RatingComponent;
import com.sun.rave.web.ui.appbase.AbstractPageBean;
import com.sun.webui.jsf.component.Body;
import com.sun.webui.jsf.component.Form;
import com.sun.webui.jsf.component.Head;
import com.sun.webui.jsf.component.Html;
import com.sun.webui.jsf.component.Hyperlink;
import com.sun.webui.jsf.component.ImageComponent;
import com.sun.webui.jsf.component.ImageHyperlink;
import com.sun.webui.jsf.component.Label;
import com.sun.webui.jsf.component.Link;
import com.sun.webui.jsf.component.Markup;
import com.sun.webui.jsf.component.Page;
import com.sun.webui.jsf.component.PanelGroup;
import com.sun.webui.jsf.component.PanelLayout;
import com.sun.webui.jsf.component.StaticText;
import com.sun.webui.jsf.component.Table;
import com.sun.webui.jsf.component.TableColumn;
import com.sun.webui.jsf.component.TableRowGroup;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.component.html.HtmlPanelGrid;
import javax.faces.context.FacesContext;
import javax.faces.convert.DateTimeConverter;
import javax.faces.event.ActionEvent;
import javax.servlet.http.HttpServletRequest;
import org.netbeans.pluginportal.system.Plugin;
import org.netbeans.pluginportal.system.SystemFileUtils;
import org.netbeans.pluginportal.ui.PluginDetail;
import org.netbeans.pluginportal.ui.PluginDetailComparator;

/**
 * <p>Page bean that corresponds to a similarly named JSP page.  This
 * class contains component definitions (and initialization code) for
 * all components that you have defined on this page, as well as
 * lifecycle methods and event handlers where you may add behavior
 * to respond to incoming events.</p>
 *
 *@author David Botterill
 */
public class PluginListPage extends AbstractPageBean {
    // <editor-fold defaultstate="collapsed" desc="Managed Component Definition">
    private int __placeholder;
    
    /**
     * <p>Automatically managed component initialization.  <strong>WARNING:</strong>
     * This method is automatically generated, so any user-specified code inserted
     * here is subject to being replaced.</p>
     */
    private void _init() throws Exception {
        dateTimeConverter1.setPattern("MMM dd, yyyy");
    }
    
    private Page page1 = new Page();
    
    public Page getPage1() {
        return page1;
    }
    
    public void setPage1(Page p) {
        this.page1 = p;
    }
    
    private Html html1 = new Html();
    
    public Html getHtml1() {
        return html1;
    }
    
    public void setHtml1(Html h) {
        this.html1 = h;
    }
    
    private Head head1 = new Head();
    
    public Head getHead1() {
        return head1;
    }
    
    public void setHead1(Head h) {
        this.head1 = h;
    }
    
    private Body body1 = new Body();
    
    public Body getBody1() {
        return body1;
    }
    
    public void setBody1(Body b) {
        this.body1 = b;
    }
    
    private Form form1 = new Form();
    
    public Form getForm1() {
        return form1;
    }
    
    public void setForm1(Form f) {
        this.form1 = f;
    }
    
    private Link link2 = new Link();
    
    public Link getLink2() {
        return link2;
    }
    
    public void setLink2(Link l) {
        this.link2 = l;
    }
    
    private PanelLayout center_container = new PanelLayout();
    
    public PanelLayout getCenter_container() {
        return center_container;
    }
    
    public void setCenter_container(PanelLayout pl) {
        this.center_container = pl;
    }
    
    private PanelLayout page_border = new PanelLayout();
    
    public PanelLayout getPage_border() {
        return page_border;
    }
    
    public void setPage_border(PanelLayout pl) {
        this.page_border = pl;
    }
    
    private PanelLayout fixed_tabs = new PanelLayout();
    
    public PanelLayout getFixed_tabs() {
        return fixed_tabs;
    }
    
    public void setFixed_tabs(PanelLayout pl) {
        this.fixed_tabs = pl;
    }
    
    private ImageComponent image1 = new ImageComponent();
    
    public ImageComponent getImage1() {
        return image1;
    }
    
    public void setImage1(ImageComponent ic) {
        this.image1 = ic;
    }
    
    private ImageComponent image2 = new ImageComponent();
    
    public ImageComponent getImage2() {
        return image2;
    }
    
    public void setImage2(ImageComponent ic) {
        this.image2 = ic;
    }
    
    private ImageHyperlink imageHyperlink1 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink1() {
        return imageHyperlink1;
    }
    
    public void setImageHyperlink1(ImageHyperlink ih) {
        this.imageHyperlink1 = ih;
    }
    
    private ImageHyperlink imageHyperlink2 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink2() {
        return imageHyperlink2;
    }
    
    public void setImageHyperlink2(ImageHyperlink ih) {
        this.imageHyperlink2 = ih;
    }
    
    private ImageHyperlink imageHyperlink3 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink3() {
        return imageHyperlink3;
    }
    
    public void setImageHyperlink3(ImageHyperlink ih) {
        this.imageHyperlink3 = ih;
    }
    
    private ImageHyperlink imageHyperlink4 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink4() {
        return imageHyperlink4;
    }
    
    public void setImageHyperlink4(ImageHyperlink ih) {
        this.imageHyperlink4 = ih;
    }
    
    private ImageHyperlink imageHyperlink5 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink5() {
        return imageHyperlink5;
    }
    
    public void setImageHyperlink5(ImageHyperlink ih) {
        this.imageHyperlink5 = ih;
    }
    
    private ImageHyperlink imageHyperlink6 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink6() {
        return imageHyperlink6;
    }
    
    public void setImageHyperlink6(ImageHyperlink ih) {
        this.imageHyperlink6 = ih;
    }
    
    private PanelLayout fixed_contentarea = new PanelLayout();
    
    public PanelLayout getFixed_contentarea() {
        return fixed_contentarea;
    }
    
    public void setFixed_contentarea(PanelLayout pl) {
        this.fixed_contentarea = pl;
    }
    
    private PanelLayout navig_breadcrumbs = new PanelLayout();
    
    public PanelLayout getNavig_breadcrumbs() {
        return navig_breadcrumbs;
    }
    
    public void setNavig_breadcrumbs(PanelLayout pl) {
        this.navig_breadcrumbs = pl;
    }
    
    private Hyperlink hyperlink1 = new Hyperlink();
    
    public Hyperlink getHyperlink1() {
        return hyperlink1;
    }
    
    public void setHyperlink1(Hyperlink h) {
        this.hyperlink1 = h;
    }
    
    private StaticText staticText1 = new StaticText();
    
    public StaticText getStaticText1() {
        return staticText1;
    }
    
    public void setStaticText1(StaticText st) {
        this.staticText1 = st;
    }
    
    private PanelGroup loginPanel1 = new PanelGroup();
    
    public PanelGroup getLoginPanel1() {
        return loginPanel1;
    }
    
    public void setLoginPanel1(PanelGroup pg) {
        this.loginPanel1 = pg;
    }
    
    private StaticText staticText2 = new StaticText();
    
    public StaticText getStaticText2() {
        return staticText2;
    }
    
    public void setStaticText2(StaticText st) {
        this.staticText2 = st;
    }
    
    private Hyperlink currentUser1 = new Hyperlink();
    
    public Hyperlink getCurrentUser1() {
        return currentUser1;
    }
    
    public void setCurrentUser1(Hyperlink h) {
        this.currentUser1 = h;
    }
    
    private Hyperlink txtLoginLogoff1 = new Hyperlink();
    
    public Hyperlink getTxtLoginLogoff1() {
        return txtLoginLogoff1;
    }
    
    public void setTxtLoginLogoff1(Hyperlink h) {
        this.txtLoginLogoff1 = h;
    }
    
    private PanelLayout fixed_contextbox = new PanelLayout();
    
    public PanelLayout getFixed_contextbox() {
        return fixed_contextbox;
    }
    
    public void setFixed_contextbox(PanelLayout pl) {
        this.fixed_contextbox = pl;
    }
    
    private PanelLayout topPanel = new PanelLayout();
    
    public PanelLayout getTopPanel() {
        return topPanel;
    }
    
    public void setTopPanel(PanelLayout pl) {
        this.topPanel = pl;
    }
    
    private Markup markup1 = new Markup();
    
    public Markup getMarkup1() {
        return markup1;
    }
    
    public void setMarkup1(Markup m) {
        this.markup1 = m;
    }
    
    private StaticText txtSearchCriteria = new StaticText();
    
    public StaticText getTxtSearchCriteria() {
        return txtSearchCriteria;
    }
    
    public void setTxtSearchCriteria(StaticText st) {
        this.txtSearchCriteria = st;
    }
    
    private Markup markup2 = new Markup();
    
    public Markup getMarkup2() {
        return markup2;
    }
    
    public void setMarkup2(Markup m) {
        this.markup2 = m;
    }
    
    private PanelLayout fixed_footer = new PanelLayout();
    
    public PanelLayout getFixed_footer() {
        return fixed_footer;
    }
    
    public void setFixed_footer(PanelLayout pl) {
        this.fixed_footer = pl;
    }
    
    private PanelLayout footer_text1 = new PanelLayout();
    
    public PanelLayout getFooter_text1() {
        return footer_text1;
    }
    
    public void setFooter_text1(PanelLayout pl) {
        this.footer_text1 = pl;
    }
    
    private PanelLayout footer_navig1 = new PanelLayout();
    
    public PanelLayout getFooter_navig1() {
        return footer_navig1;
    }
    
    public void setFooter_navig1(PanelLayout pl) {
        this.footer_navig1 = pl;
    }
    
    private StaticText staticText30 = new StaticText();
    
    public StaticText getStaticText30() {
        return staticText30;
    }
    
    public void setStaticText30(StaticText st) {
        this.staticText30 = st;
    }
    
    private StaticText staticText31 = new StaticText();
    
    public StaticText getStaticText31() {
        return staticText31;
    }
    
    public void setStaticText31(StaticText st) {
        this.staticText31 = st;
    }
    
    private Hyperlink hyperlink2 = new Hyperlink();
    
    public Hyperlink getHyperlink2() {
        return hyperlink2;
    }
    
    public void setHyperlink2(Hyperlink h) {
        this.hyperlink2 = h;
    }
    
    private StaticText staticText32 = new StaticText();
    
    public StaticText getStaticText32() {
        return staticText32;
    }
    
    public void setStaticText32(StaticText st) {
        this.staticText32 = st;
    }
    
    private Hyperlink hyperlink3 = new Hyperlink();
    
    public Hyperlink getHyperlink3() {
        return hyperlink3;
    }
    
    public void setHyperlink3(Hyperlink h) {
        this.hyperlink3 = h;
    }
    
    private StaticText staticText33 = new StaticText();
    
    public StaticText getStaticText33() {
        return staticText33;
    }
    
    public void setStaticText33(StaticText st) {
        this.staticText33 = st;
    }
    
    private StaticText staticText34 = new StaticText();
    
    public StaticText getStaticText34() {
        return staticText34;
    }
    
    public void setStaticText34(StaticText st) {
        this.staticText34 = st;
    }
    
    private Hyperlink hyperlink4 = new Hyperlink();
    
    public Hyperlink getHyperlink4() {
        return hyperlink4;
    }
    
    public void setHyperlink4(Hyperlink h) {
        this.hyperlink4 = h;
    }
    
    private StaticText staticText35 = new StaticText();
    
    public StaticText getStaticText35() {
        return staticText35;
    }
    
    public void setStaticText35(StaticText st) {
        this.staticText35 = st;
    }
    
    private Hyperlink hyperlink5 = new Hyperlink();
    
    public Hyperlink getHyperlink5() {
        return hyperlink5;
    }
    
    public void setHyperlink5(Hyperlink h) {
        this.hyperlink5 = h;
    }
    
    private StaticText staticText36 = new StaticText();
    
    public StaticText getStaticText36() {
        return staticText36;
    }
    
    public void setStaticText36(StaticText st) {
        this.staticText36 = st;
    }
    
    private Hyperlink hyperlink6 = new Hyperlink();
    
    public Hyperlink getHyperlink6() {
        return hyperlink6;
    }
    
    public void setHyperlink6(Hyperlink h) {
        this.hyperlink6 = h;
    }
    
    private PanelLayout tof1 = new PanelLayout();
    
    public PanelLayout getTof1() {
        return tof1;
    }
    
    public void setTof1(PanelLayout pl) {
        this.tof1 = pl;
    }
    
    private StaticText staticText37 = new StaticText();
    
    public StaticText getStaticText37() {
        return staticText37;
    }
    
    public void setStaticText37(StaticText st) {
        this.staticText37 = st;
    }
    
    private Hyperlink hyperlink7 = new Hyperlink();
    
    public Hyperlink getHyperlink7() {
        return hyperlink7;
    }
    
    public void setHyperlink7(Hyperlink h) {
        this.hyperlink7 = h;
    }
    
    private PanelLayout bottomPanel1 = new PanelLayout();
    
    public PanelLayout getBottomPanel1() {
        return bottomPanel1;
    }
    
    public void setBottomPanel1(PanelLayout pl) {
        this.bottomPanel1 = pl;
    }
    
    private Markup markup4 = new Markup();
    
    public Markup getMarkup4() {
        return markup4;
    }
    
    public void setMarkup4(Markup m) {
        this.markup4 = m;
    }
    
    private Markup markup5 = new Markup();
    
    public Markup getMarkup5() {
        return markup5;
    }
    
    public void setMarkup5(Markup m) {
        this.markup5 = m;
    }
    
    private Table table = new Table();
    
    public Table getTable() {
        return table;
    }
    
    public void setTable(Table t) {
        this.table = t;
    }
    
    private TableRowGroup tableRowGroup = new TableRowGroup();
    
    public TableRowGroup getTableRowGroup() {
        return tableRowGroup;
    }
    
    public void setTableRowGroup(TableRowGroup trg) {
        this.tableRowGroup = trg;
    }
    
    private Markup markup16 = new Markup();
    
    public Markup getMarkup16() {
        return markup16;
    }
    
    public void setMarkup16(Markup m) {
        this.markup16 = m;
    }
    
    private PanelLayout categoryDetailPanel = new PanelLayout();
    
    public PanelLayout getCategoryDetailPanel() {
        return categoryDetailPanel;
    }
    
    public void setCategoryDetailPanel(PanelLayout pl) {
        this.categoryDetailPanel = pl;
    }
    
    private PanelLayout ratingPanel = new PanelLayout();
    
    public PanelLayout getRatingPanel() {
        return ratingPanel;
    }
    
    public void setRatingPanel(PanelLayout pl) {
        this.ratingPanel = pl;
    }
    
    private RatingComponent rating2 = new RatingComponent();
    
    public RatingComponent getRating2() {
        return rating2;
    }
    
    public void setRating2(RatingComponent rc) {
        this.rating2 = rc;
    }
    
    private Hyperlink pluginNameLink = new Hyperlink();
    
    public Hyperlink getPluginNameLink() {
        return pluginNameLink;
    }
    
    public void setPluginNameLink(Hyperlink h) {
        this.pluginNameLink = h;
    }
    
    private Markup markup15 = new Markup();
    
    public Markup getMarkup15() {
        return markup15;
    }
    
    public void setMarkup15(Markup m) {
        this.markup15 = m;
    }
    
    private Markup markup17 = new Markup();
    
    public Markup getMarkup17() {
        return markup17;
    }
    
    public void setMarkup17(Markup m) {
        this.markup17 = m;
    }
    
    private Markup markup18 = new Markup();
    
    public Markup getMarkup18() {
        return markup18;
    }
    
    public void setMarkup18(Markup m) {
        this.markup18 = m;
    }
    
    private Markup markup19 = new Markup();
    
    public Markup getMarkup19() {
        return markup19;
    }
    
    public void setMarkup19(Markup m) {
        this.markup19 = m;
    }
    
    private HtmlPanelGrid categoryDetailBottomGrid = new HtmlPanelGrid();
    
    public HtmlPanelGrid getCategoryDetailBottomGrid() {
        return categoryDetailBottomGrid;
    }
    
    public void setCategoryDetailBottomGrid(HtmlPanelGrid hpg) {
        this.categoryDetailBottomGrid = hpg;
    }
    
    private PanelLayout leftPanel = new PanelLayout();
    
    public PanelLayout getLeftPanel() {
        return leftPanel;
    }
    
    public void setLeftPanel(PanelLayout pl) {
        this.leftPanel = pl;
    }
    
    private ImageHyperlink imageHyperlink8 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink8() {
        return imageHyperlink8;
    }
    
    public void setImageHyperlink8(ImageHyperlink ih) {
        this.imageHyperlink8 = ih;
    }
    
    private Markup markup20 = new Markup();
    
    public Markup getMarkup20() {
        return markup20;
    }
    
    public void setMarkup20(Markup m) {
        this.markup20 = m;
    }
    
    private PanelLayout rightPanel = new PanelLayout();
    
    public PanelLayout getRightPanel() {
        return rightPanel;
    }
    
    public void setRightPanel(PanelLayout pl) {
        this.rightPanel = pl;
    }
    
    private Label label5 = new Label();
    
    public Label getLabel5() {
        return label5;
    }
    
    public void setLabel5(Label l) {
        this.label5 = l;
    }
    
    private Hyperlink lnkAuthor = new Hyperlink();
    
    public Hyperlink getLnkAuthor() {
        return lnkAuthor;
    }
    
    public void setLnkAuthor(Hyperlink h) {
        this.lnkAuthor = h;
    }
    
    private Label label6 = new Label();
    
    public Label getLabel6() {
        return label6;
    }
    
    public void setLabel6(Label l) {
        this.label6 = l;
    }
    
    private StaticText txtDownloads2 = new StaticText();
    
    public StaticText getTxtDownloads2() {
        return txtDownloads2;
    }
    
    public void setTxtDownloads2(StaticText st) {
        this.txtDownloads2 = st;
    }
    
    private Markup markup24 = new Markup();
    
    public Markup getMarkup24() {
        return markup24;
    }
    
    public void setMarkup24(Markup m) {
        this.markup24 = m;
    }
    
    private StaticText txtSummary2 = new StaticText();
    
    public StaticText getTxtSummary2() {
        return txtSummary2;
    }
    
    public void setTxtSummary2(StaticText st) {
        this.txtSummary2 = st;
    }
    
    private Markup markup25 = new Markup();
    
    public Markup getMarkup25() {
        return markup25;
    }
    
    public void setMarkup25(Markup m) {
        this.markup25 = m;
    }
    
    private Hyperlink lnkReadMore = new Hyperlink();
    
    public Hyperlink getLnkReadMore() {
        return lnkReadMore;
    }
    
    public void setLnkReadMore(Hyperlink h) {
        this.lnkReadMore = h;
    }
    
    private TableColumn tableColumn1 = new TableColumn();
    
    public TableColumn getTableColumn1() {
        return tableColumn1;
    }
    
    public void setTableColumn1(TableColumn tc) {
        this.tableColumn1 = tc;
    }
    
    private PanelGroup groupPanel1 = new PanelGroup();
    
    public PanelGroup getGroupPanel1() {
        return groupPanel1;
    }
    
    public void setGroupPanel1(PanelGroup pg) {
        this.groupPanel1 = pg;
    }
    
    private HtmlPanelGrid main_table = new HtmlPanelGrid();
    
    public HtmlPanelGrid getMain_table() {
        return main_table;
    }
    
    public void setMain_table(HtmlPanelGrid hpg) {
        this.main_table = hpg;
    }
    
    private PanelLayout left_col = new PanelLayout();
    
    public PanelLayout getLeft_col() {
        return left_col;
    }
    
    public void setLeft_col(PanelLayout pl) {
        this.left_col = pl;
    }
    
    private PanelLayout right_col1 = new PanelLayout();
    
    public PanelLayout getRight_col1() {
        return right_col1;
    }
    
    public void setRight_col1(PanelLayout pl) {
        this.right_col1 = pl;
    }
    
    private PanelLayout right_col_area = new PanelLayout();
    
    public PanelLayout getRight_col_area() {
        return right_col_area;
    }
    
    public void setRight_col_area(PanelLayout pl) {
        this.right_col_area = pl;
    }
    
    private StaticText staticText4 = new StaticText();
    
    public StaticText getStaticText4() {
        return staticText4;
    }
    
    public void setStaticText4(StaticText st) {
        this.staticText4 = st;
    }
    
    private Markup markup6 = new Markup();
    
    public Markup getMarkup6() {
        return markup6;
    }
    
    public void setMarkup6(Markup m) {
        this.markup6 = m;
    }
    
    private PanelLayout categoryLayout = new PanelLayout();
    
    public PanelLayout getCategoryLayout() {
        return categoryLayout;
    }
    
    public void setCategoryLayout(PanelLayout pl) {
        this.categoryLayout = pl;
    }
    
    private Markup markup7 = new Markup();
    
    public Markup getMarkup7() {
        return markup7;
    }
    
    public void setMarkup7(Markup m) {
        this.markup7 = m;
    }
    
    private ImageHyperlink lnkCloud = new ImageHyperlink();
    
    public ImageHyperlink getLnkCloud() {
        return lnkCloud;
    }
    
    public void setLnkCloud(ImageHyperlink ih) {
        this.lnkCloud = ih;
    }
    
    private PanelGroup orderByPanel1 = new PanelGroup();
    
    public PanelGroup getOrderByPanel1() {
        return orderByPanel1;
    }
    
    public void setOrderByPanel1(PanelGroup pg) {
        this.orderByPanel1 = pg;
    }
    
    private StaticText staticText3 = new StaticText();
    
    public StaticText getStaticText3() {
        return staticText3;
    }
    
    public void setStaticText3(StaticText st) {
        this.staticText3 = st;
    }
    
    private Hyperlink lnkOrderByName = new Hyperlink();
    
    public Hyperlink getLnkOrderByName() {
        return lnkOrderByName;
    }
    
    public void setLnkOrderByName(Hyperlink h) {
        this.lnkOrderByName = h;
    }
    
    private Hyperlink lnkOrderByDate = new Hyperlink();
    
    public Hyperlink getLnkOrderByDate() {
        return lnkOrderByDate;
    }
    
    public void setLnkOrderByDate(Hyperlink h) {
        this.lnkOrderByDate = h;
    }
    
    private Hyperlink lnkOrderByRating = new Hyperlink();
    
    public Hyperlink getLnkOrderByRating() {
        return lnkOrderByRating;
    }
    
    public void setLnkOrderByRating(Hyperlink h) {
        this.lnkOrderByRating = h;
    }
    
    private Hyperlink lnkOrderByDownloads = new Hyperlink();
    
    public Hyperlink getLnkOrderByDownloads() {
        return lnkOrderByDownloads;
    }
    
    public void setLnkOrderByDownloads(Hyperlink h) {
        this.lnkOrderByDownloads = h;
    }
    
    private Label label1 = new Label();
    
    public Label getLabel1() {
        return label1;
    }
    
    public void setLabel1(Label l) {
        this.label1 = l;
    }
    
    private Markup markup3 = new Markup();
    
    public Markup getMarkup3() {
        return markup3;
    }
    
    public void setMarkup3(Markup m) {
        this.markup3 = m;
    }
    
    private StaticText txtDateAdded = new StaticText();
    
    public StaticText getTxtDateAdded() {
        return txtDateAdded;
    }
    
    public void setTxtDateAdded(StaticText st) {
        this.txtDateAdded = st;
    }
    
    private DateTimeConverter dateTimeConverter1 = new DateTimeConverter();
    
    public DateTimeConverter getDateTimeConverter1() {
        return dateTimeConverter1;
    }
    
    public void setDateTimeConverter1(DateTimeConverter dtc) {
        this.dateTimeConverter1 = dtc;
    }
    
    private HtmlPanelGrid gridPanel1 = new HtmlPanelGrid();
    
    public HtmlPanelGrid getGridPanel1() {
        return gridPanel1;
    }
    
    public void setGridPanel1(HtmlPanelGrid hpg) {
        this.gridPanel1 = hpg;
    }
    
    private ImageHyperlink imageHyperlink7 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink7() {
        return imageHyperlink7;
    }
    
    public void setImageHyperlink7(ImageHyperlink ih) {
        this.imageHyperlink7 = ih;
    }
    
    private Label label2 = new Label();
    
    public Label getLabel2() {
        return label2;
    }
    
    public void setLabel2(Label l) {
        this.label2 = l;
    }
    
    private StaticText txtVersion = new StaticText();
    
    public StaticText getTxtVersion() {
        return txtVersion;
    }
    
    public void setTxtVersion(StaticText st) {
        this.txtVersion = st;
    }
    
    private HtmlPanelGrid gridPanel2 = new HtmlPanelGrid();
    
    public HtmlPanelGrid getGridPanel2() {
        return gridPanel2;
    }
    
    public void setGridPanel2(HtmlPanelGrid hpg) {
        this.gridPanel2 = hpg;
    }
    
    private PanelLayout namePanel = new PanelLayout();
    
    public PanelLayout getNamePanel() {
        return namePanel;
    }
    
    public void setNamePanel(PanelLayout pl) {
        this.namePanel = pl;
    }
    
    private Label label3 = new Label();
    
    public Label getLabel3() {
        return label3;
    }
    
    public void setLabel3(Label l) {
        this.label3 = l;
    }
    
    private StaticText txtDateUpdated = new StaticText();
    
    public StaticText getTxtDateUpdated() {
        return txtDateUpdated;
    }
    
    public void setTxtDateUpdated(StaticText st) {
        this.txtDateUpdated = st;
    }
    
    // </editor-fold>
    
    /**
     * <p>Construct a new Page bean instance.</p>
     */
    public PluginListPage() {
    }
    
    /**
     * <p>Callback method that is called whenever a page is navigated to,
     * either directly via a URL, or indirectly via page navigation.
     * Customize this method to acquire resources that will be needed
     * for event handlers and lifecycle methods, whether or not this
     * page is performing post back processing.</p>
     *
     * <p>Note that, if the current request is a postback, the property
     * values of the components do <strong>not</strong> represent any
     * values submitted with this request.  Instead, they represent the
     * property values that were saved for this view when it was rendered.</p>
     */
    public void init() {
        // Perform initializations inherited from our superclass
        super.init();
        // Perform application initialization that must complete
        // *before* managed components are initialized
        // TODO - add your own initialiation code here
        
        // <editor-fold defaultstate="collapsed" desc="Managed Component Initialization">
        // Initialize automatically managed components
        // *Note* - this logic should NOT be modified
        try {
            _init();
        } catch (Exception e) {
            log("PluginListPage Initialization Failure", e);
            throw e instanceof FacesException ? (FacesException) e: new FacesException(e);
        }
        
        // </editor-fold>
        // Perform application initialization that must complete
        // *after* managed components are initialized
        // TODO - add your own initialization code here
        if(null == getSessionBean1().getCurrentOrderBy()) {
            getSessionBean1().setCurrentOrderBy(OrderBy.NAME);
            lnkOrderByName.setDisabled(true);
        }
        
        getSessionBean1().setCurrentPageName("PluginListPage");
        
        /**
         * Process a GET type request.
         */
        HttpServletRequest request = (HttpServletRequest)FacesContext.getCurrentInstance().getExternalContext().getRequest();
        String [] authors = request.getParameterValues("author");
        if(null != authors && authors.length == 1) {
            getSessionBean1().setCurrentSearchCriteria("Plugins for: " + authors[0]);
            Plugin [] foundPlugins = this.getApplicationBean1().getPluginSystem().getPluginsByAuthor(authors[0]);
            getSessionBean1().setCurrentPlugins(foundPlugins);
        } else {
            String [] searchall = request.getParameterValues("searchall");
            if(null != searchall && searchall.length == 1) {
                Plugin [] foundPlugins = this.getApplicationBean1().getPluginSystem().getPlugins(null);
                getSessionBean1().setCurrentPlugins(foundPlugins);
                getSessionBean1().setCurrentSearchCriteria("Search criteria: show all plugins");
            } else {
                String [] search = request.getParameterValues("search");
                if(null != search && search.length == 1) {
                    Plugin [] foundPlugins = this.getApplicationBean1().getPluginSystem().getPlugins(search[0]);
                    getSessionBean1().setCurrentPlugins(foundPlugins);
                    getSessionBean1().setCurrentSearchCriteria("Search criteria: " + search[0]);
                }
                
            }
            
            
            
        }
    }
    
    /**
     * <p>Callback method that is called after the component tree has been
     * restored, but before any event processing takes place.  This method
     * will <strong>only</strong> be called on a postback request that
     * is processing a form submit.  Customize this method to allocate
     * resources that will be required in your event handlers.</p>
     */
    public void preprocess() {
    }
    
    /**
     * <p>Callback method that is called just before rendering takes place.
     * This method will <strong>only</strong> be called for the page that
     * will actually be rendered (and not, for example, on a page that
     * handled a postback and then navigated to a different page).  Customize
     * this method to allocate resources that will be required for rendering
     * this page.</p>
     */
    public void prerender() {
        if(getSessionBean1().isCategoryInCloudView()) {
            lnkCloud.setImageURL("/resources/cloud_ctrl_display_as_cloud.png");
            lnkCloud.setToolTip("Click to show as List");
            if(null != this.getCategoryLayout().getChildren()) {
                this.getCategoryLayout().getChildren().clear();
            }
            ArrayList<Hyperlink> cloudLinks = this.getSessionBean1().getCategoryCloudLinks();
            /**
             * Now that we have the links, we need to add spaces between them
             * then add them to the panel.
             */
            ArrayList<UIComponent> categoryCloud = new ArrayList();
            Iterator<Hyperlink> cloudIterator = cloudLinks.iterator();
            StaticText spaceStaticText = null;
            while(cloudIterator.hasNext()) {
                Hyperlink currentLink = cloudIterator.next();
                categoryCloud.add(currentLink);
                spaceStaticText = new StaticText();
                spaceStaticText.setText("&nbsp;");
                spaceStaticText.setEscape(false);
                categoryCloud.add(spaceStaticText);
//            spaceStaticText = new StaticText();
//            spaceStaticText.setText("&nbsp;");
//            spaceStaticText.setEscape(false);
//            newList.add(spaceStaticText);
            }
            this.getCategoryLayout().getChildren().addAll(categoryCloud);
        } else {
            lnkCloud.setImageURL("/resources/cloud_ctrl_display_as_list.png");
            lnkCloud.setToolTip("Click to show as cloud");
            if(null != this.getCategoryLayout().getChildren()) {
                this.getCategoryLayout().getChildren().clear();
            }
            HtmlPanelGrid categoryPanel = new HtmlPanelGrid();
            /**
             * Populate the categoryPanel
             *
             */
            categoryPanel.getChildren().addAll(this.getSessionBean1().getCategoryList());
            this.getCategoryLayout().getChildren().add(categoryPanel);
        }
        
        loadPlugins();
    }
    
    /**
     * <p>Callback method that is called after rendering is completed for
     * this request, if <code>init()</code> was called (regardless of whether
     * or not this was the page that was actually rendered).  Customize this
     * method to release resources acquired in the <code>init()</code>,
     * <code>preprocess()</code>, or <code>prerender()</code> methods (or
     * acquired during execution of an event handler).</p>
     */
    public void destroy() {
    }
    
    private void loadPlugins() {
        Plugin [] tempPlugins = getSessionBean1().getCurrentPlugins();
        if(null != tempPlugins) {
            ArrayList<PluginDetail> pluginList = new ArrayList();
            PluginDetail currentPlugin = null;
            for(int ii=0;ii < tempPlugins.length;ii++) {
                currentPlugin = new PluginDetail();
                currentPlugin.setAuthor(tempPlugins[ii].getAuthor_userid());
                if(null == tempPlugins[ii].getImage_filename() ||
                        tempPlugins[ii].getImage_filename().equals("")) {
                    currentPlugin.setImage_url(FileUtils.defaultImage);
                } else {
                    currentPlugin.setImage_url(SystemFileUtils.getImageURLString() + File.separator +  tempPlugins[ii].getImage_filename());
                }
                currentPlugin.setPluginid(tempPlugins[ii].getPluginid());
                if(null == tempPlugins[ii].getNbm_filename() ||
                        tempPlugins[ii].getNbm_filename().equals("")) {
                    currentPlugin.setDownloads("not available");
                } else {
                    if(null != tempPlugins[ii].getDownloads()) {
                        currentPlugin.setDownloads(Long.toString(tempPlugins[ii].getDownloads().longValue()));
                    } else {
                        currentPlugin.setDownloads("0");
                    }
                }
                currentPlugin.setName(tempPlugins[ii].getPlugin_name());
                currentPlugin.setSummary(tempPlugins[ii].getSummary());
                currentPlugin.setDate_added(tempPlugins[ii].getDate_added());
                currentPlugin.setDate_updated(tempPlugins[ii].getDate_last_updated());
                String dislplayCat = (String) this.getApplicationBean1().getDisplayCategoryMapById().get(tempPlugins[ii].getCategoryid());
                currentPlugin.setVersion(tempPlugins[ii].getVersion());
                currentPlugin.setDisplay_category(dislplayCat);
                /**
                 * Set the URL to a GET style
                 */
                currentPlugin.setUrl("http://" + SystemFileUtils.getServerHost() + "/PluginPortal/faces/PluginDetailPage.jsp?pluginid=" + tempPlugins[ii].getPluginid());
                currentPlugin.setOwnerUrl("http://" + SystemFileUtils.getServerHost() + "/PluginPortal/faces/PluginListPage.jsp?author=" + tempPlugins[ii].getAuthor_userid());
                
                if(null != tempPlugins[ii].getAverage_rating()) {
                    currentPlugin.setRating(tempPlugins[ii].getAverage_rating().doubleValue());
                } else {
                    currentPlugin.setRating(0.0);
                }
                if(null!=tempPlugins[ii].getRatings()) {
                    currentPlugin.setTotal_raters(tempPlugins[ii].getRatings().size());
                } else {
                    currentPlugin.setTotal_raters(0);
                }
                currentPlugin.setAvgRatingText("Rated by " + currentPlugin.getTotal_raters() + " users.");
                
                pluginList.add(currentPlugin);
            }
            PluginDetail [] details = (PluginDetail [])pluginList.toArray(new PluginDetail[0]);
            /**
             * Sort the details.
             */
            Arrays.sort(details,new PluginDetailComparator(getSessionBean1().getCurrentOrderBy()));
            
            this.setPluginDetails(details);
            getSessionBean1().getPluginDetailsDataProvider().setArray(this.getPluginDetails());
        }
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected SessionBean1 getSessionBean1() {
        return (SessionBean1)getBean("SessionBean1");
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected ApplicationBean1 getApplicationBean1() {
        return (ApplicationBean1)getBean("ApplicationBean1");
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected RequestBean1 getRequestBean1() {
        return (RequestBean1)getBean("RequestBean1");
    }
    
    public String currentUser_action() {
        return "myplugins";
    }
    
    public String txtLoginLogoff_action() {
        if(this.getSessionBean1().isLoggedIn()) {
            this.getSessionBean1().setCurrentUserId(null);
            return null;
        } else {
            this.getSessionBean1().setReturnFromLoginPage("list");
            return "login";
        }
        
    }
    
    public String btnFinish_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String btnCancel_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String lnkShow_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String orderByLink1_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    /**
     * Holds value of property pluginDetails.
     */
    private PluginDetail[] pluginDetails;
    
    /**
     * Getter for property pluginDetails.
     * @return Value of property pluginDetails.
     */
    public PluginDetail[] getPluginDetails() {
        return this.pluginDetails;
    }
    
    /**
     * Setter for property pluginDetails.
     * @param pluginDetails New value of property pluginDetails.
     */
    public void setPluginDetails(PluginDetail[] pluginDetails) {
        this.pluginDetails = pluginDetails;
    }
    
    public String lnkAuthor_action() {
        RowKey rowKey = tableRowGroup.getRowKey();
        String searchString = (String) this.getSessionBean1().getPluginDetailsDataProvider().getValue("author", rowKey);
        
        getSessionBean1().setCurrentSearchCriteria("Plugins for: " + searchString);
        
        Plugin [] foundPlugins = this.getApplicationBean1().getPluginSystem().getPluginsByAuthor(searchString);
        getSessionBean1().setCurrentPlugins(foundPlugins);
        
        return "list";
    }
    
    public String pluginNameLink_action() {
        RowKey rowKey = tableRowGroup.getRowKey();
        Long pluginid = (Long) getSessionBean1().getPluginDetailsDataProvider().getValue("pluginid", rowKey);
        Plugin selectedPlugin = this.getApplicationBean1().getPluginSystem().getPlugin(pluginid);
        getSessionBean1().setCurrentPlugin(selectedPlugin);
        
        return "detail";
    }
    
    public String lnkCloud_action() {
        if(getSessionBean1().isCategoryInCloudView()) {
            getSessionBean1().setCategoryInCloudView(false);
        } else {
            getSessionBean1().setCategoryInCloudView(true);
        }
        return null;
    }
    
    public String lnkOrderByDate_action() {
        getSessionBean1().setCurrentOrderBy(OrderBy.DATE);
        lnkOrderByDate.setDisabled(true);
        lnkOrderByDownloads.setDisabled(false);
        lnkOrderByName.setDisabled(false);
        lnkOrderByRating.setDisabled(false);
        return null;
    }
    public String lnkOrderByRating_action() {
        getSessionBean1().setCurrentOrderBy(OrderBy.RATING);
        lnkOrderByDate.setDisabled(false);
        lnkOrderByDownloads.setDisabled(false);
        lnkOrderByName.setDisabled(false);
        lnkOrderByRating.setDisabled(true);
        
        return null;
    }
    
    public String lnkOrderByDownloads_action() {
        getSessionBean1().setCurrentOrderBy(OrderBy.DOWNLOADS);
        lnkOrderByDate.setDisabled(false);
        lnkOrderByDownloads.setDisabled(true);
        lnkOrderByName.setDisabled(false);
        lnkOrderByRating.setDisabled(false);
        
        
        return null;
    }
    
    public String lnkOrderByName_action() {
        getSessionBean1().setCurrentOrderBy(OrderBy.NAME);
        lnkOrderByDate.setDisabled(false);
        lnkOrderByDownloads.setDisabled(false);
        lnkOrderByName.setDisabled(true);
        lnkOrderByRating.setDisabled(false);
        
        return null;
    }
    
    public String lnkCategories_action() {
        RowKey rowKey = tableRowGroup.getRowKey();
        String category = (String) this.getSessionBean1().getPluginDetailsDataProvider().getValue("display_category", rowKey);
        
        getSessionBean1().setCurrentCategoryName(category);
        
        return "category";
    }
    
    public String category_action() {
        this.tableRowGroup.setPage(1);
        return "category";
    }
    
    public void category_action(ActionEvent ae) {
        
        ActionEvent action = ae;
        String currentCategoryName = ((Hyperlink)ae.getComponent()).getType();
        getSessionBean1().setCurrentCategoryName(currentCategoryName);
        return;
    }
    
}

