/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/

package org.netbeans.pluginportal.data;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import org.netbeans.pluginportal.system.Rating;

/**
 * Entity class RatingImpl
 * 
 * @author David Botterill
 */
@Entity
public class RatingImpl implements Serializable, Rating {

    @ManyToOne()
    private PluginImpl plugin;
    
    public RatingImpl() {
    }
    
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    
    
    /**
     * Gets the id of this RatingImpl.
     * 
     * @return the id
     */
    public Long getId() {
        return this.id;
    }
    
    /**
     * Sets the id of this RatingImpl to the specified value.
     * 
     * @param id the new id
     */
    public void setId(Long id) {
        this.id = id;
    }
    
    public PluginImpl getPlugin() {
        return plugin;
    }
    
    public void setPlugin(PluginImpl inPlugin) {
        plugin=inPlugin;
    }
    
    /**
     * Returns a hash code value for the object.  This implementation computes
     * a hash code value based on the id fields in this object.
     * @return a hash code value for this object.
     */
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }
    
    /**
     * Determines whether another object is equal to this RatingImpl.  The result is
     * <code>true</code> if and only if the argument is not null and is a RatingImpl object that
     * has the same id field values as this object.
     * 
     * @param object the reference object with which to compare
     * @return <code>true</code> if this object is the same as the argument;
     * <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof RatingImpl)) {
            return false;
        }
        RatingImpl other = (RatingImpl)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }
    
    /**
     * Returns a string representation of the object.  This implementation constructs
     * that representation based on the id fields.
     * @return a string representation of the object.
     */
    @Override
    public String toString() {
        return "org.netbeans.pluginportal.data.Rating[id=" + id + "]";
    }
    
    
    /**
     * Holds value of property rating_level.
     */
    private Integer rating_level;
    
    /**
     * Getter for property rating_level.
     * @return Value of property rating_level.
     */
    public Integer getRating_level() {
        return this.rating_level;
    }
    
    /**
     * Setter for property rating_level.
     * @param rating_level New value of property rating_level.
     */
    public void setRating_level(Integer rating_level) {
        this.rating_level = rating_level;
    }
    
    /**
     * Holds value of property userid.
     */
    private String userid;
    
    /**
     * Getter for property userid.
     * @return Value of property userid.
     */
    public String getUserid() {
        return this.userid;
    }
    
    /**
     * Setter for property userid.
     * @param userid New value of property userid.
     */
    public void setUserid(String userid) {
        this.userid = userid;
    }
    
    /**
     * Holds value of property date_rated.
     */
    @Temporal(TemporalType.DATE)
    private java.util.Date date_rated;
    
    /**
     * Getter for property date_rated.
     * @return Value of property date_rated.
     */
    public java.util.Date getDate_rated() {
        return this.date_rated;
    }
    
    /**
     * Setter for property date_rated.
     * @param date_rated New value of property date_rated.
     */
    public void setDate_rated(java.util.Date date_rated) {
        this.date_rated = date_rated;
    }
    
}
