<?xml version="1.0" encoding="UTF-8" ?>
<!--
DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.

Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.


The contents of this file are subject to the terms of either the GNU
General Public License Version 2 only ("GPL") or the Common
Development and Distribution License("CDDL") (collectively, the
"License"). You may not use this file except in compliance with the
License. You can obtain a copy of the License at
http://www.netbeans.org/cddl-gplv2.html
or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
specific language governing permissions and limitations under the
License.  When distributing the software, include this License Header
Notice in each file and include the License file at
nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
particular file as subject to the "Classpath" exception as provided
by Sun in the GPL Version 2 section of the License file that
accompanied this code. If applicable, add the following below the
License Header, with the fields enclosed by brackets [] replaced by
your own identifying information:
"Portions Copyrighted [year] [name of copyright owner]"

Contributor(s):

The Original Software is NetBeans. The Initial Developer of the Original
Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
Microsystems, Inc. All Rights Reserved.

If you wish your version of this file to be governed by only the CDDL
or only the GPL Version 2, indicate your decision by adding
"[Contributor] elects to include this software in this distribution
under the [CDDL or GPL Version 2] license." If you do not indicate a
single choice of license, a recipient has the option to distribute
your version of this file under either the CDDL, the GPL Version 2 or
to extend the choice of license to its licensees as provided above.
However, if you add GPL Version 2 code and therefore, elected the GPL
Version 2 license, then the option applies only if the new code is
made subject to such option by the copyright holder.
-->
<!DOCTYPE stylesheet [
    <!ENTITY show_bug "http://www.netbeans.org/issues/show_bug.cgi">
    <!ENTITY bug_list "http://www.netbeans.org/issues/buglist.cgi">
]>


<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html" indent="yes"/>
<xsl:key name="components" match="component" use="@name"/>

<xsl:template match="qbuild-report">
<html> 
<head>   
<title><xsl:value-of select="@name"/> build Quality Report</title>
    <LINK REL="Stylesheet" HREF="http://www.netbeans.org/netbeans.css" TYPE="text/css" TITLE="NetBeans OpenSource Style"/>
</head>
    <H1><xsl:value-of select="@name"/> Verification Report</H1>
    <B>Build number: </B><B><xsl:value-of select="@build"/></B>
    <xsl:variable name="date" select="@date"/>
    <BR/><B>Date built/tested: </B><I><xsl:value-of select="@date"/></I>
    
    <BR/><B>Recommended: <FONT COLOR="#FF0000">
        <xsl:choose>
            <xsl:when test="@recommend='yes'">
                Yes
            </xsl:when>
            <xsl:otherwise>
                No
            </xsl:otherwise>
        </xsl:choose>    
    </FONT></B>
    
    <P><A HREF="index.html">Q-builds index</A></P>
    <P>
    <xsl:choose>
            <xsl:when test="@recommend='no'">
                       We are sorry to say that today's development build of NetBeans.next <xsl:value-of select="@build"/> didn't meet all of the criteria
                       necessary for announcing it as Q-Build. Testing process discovered several problems reporting unexpected exceptions or
                       regressions in functionality. If you are interested in details please read below. 
            </xsl:when>               
            <xsl:otherwise>
                       We are pleased to announce that build <xsl:value-of select="@build"/> of NetBeans.next was
                       successfully tested and meets all criteria of q-build. So enjoy ! 
            </xsl:otherwise>
        </xsl:choose>    
    </P>
    
    <H3>Q-build stoppers</H3>
    <P>
        <xsl:for-each select="//issue[@stopper='yes']">
            <xsl:sort select="@priority"/>
            <a>
            <xsl:attribute name="href">&show_bug;?id=<xsl:value-of select="@id"/></xsl:attribute>
            <xsl:value-of select="@id"/>
            </a>
            - <b><xsl:value-of select="@priority"/></b>:
            <xsl:value-of select="short_desc"/>
            <br/>
        </xsl:for-each>
    
    </P>
    <H3>Bugs to Be Fixed by next Q-build</H3>
    <P>
        <xsl:for-each select="//issue[(@priority='P1' or @priority='P2') and @stopper='no' and @to-fix='yes']">
            <xsl:sort select="@priority"/>
            <a>
            <xsl:attribute name="href">&show_bug;?id=<xsl:value-of select="@id"/></xsl:attribute>
            <xsl:value-of select="@id"/>
            </a>
            - <b><xsl:value-of select="@priority"/></b>:
            <xsl:value-of select="short_desc"/>
            <br/>
        </xsl:for-each>
    </P>
    
        
    <P>Use <a><xsl:attribute name="href">&bug_list;?issue_id=<xsl:for-each select="//issue[(@priority='P1' or @priority='P2') and (@stopper='yes' or @to-fix='yes')]">
        <xsl:value-of select="@id"/>%2c+</xsl:for-each>    
    </xsl:attribute>this query</a> to check the current status of the bugs from the above list.</P> 
    
    <H3><xsl:text disable-output-escaping="yes">&quot;Don't&quot;s for This Build</xsl:text></H3>    
    <UL>
    <xsl:for-each select="/qbuild-report/donts">
        <LI><xsl:value-of select="."/></LI>
    </xsl:for-each>    
    </UL>
    
    <H3>Test Results</H3>
    The following table provides a complete list of all defects discovered during the testing of the <xsl:value-of select="/qbuild-report/@name"/>.
    <P><TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" WIDTH="90%" CLASS="tablebg">
        <TR>
            <TD><TABLE BORDER="0" CELLPADDING="3" WIDTH="100%">
                <TR>
                    <TD COLSPAN="6"><FONT COLOR="white">Build #<xsl:value-of select="@build"/> Results</FONT></TD>
                </TR>
                <TR CLASS="tablecbg">
                    <TD ALIGN="CENTER" WIDTH="20%">Module</TD>
                    <TD ALIGN="CENTER" WIDTH="16%">P1</TD>
                    <TD ALIGN="CENTER" WIDTH="16%">P2</TD>
                    <TD ALIGN="CENTER" WIDTH="16%">P3</TD>
                    <TD ALIGN="CENTER" WIDTH="16%">P4</TD>
                    <TD ALIGN="CENTER" WIDTH="16%">P5</TD>
                </TR>
                
                <xsl:for-each select="//component[generate-id(.)=generate-id(key('components',@name)[1])]">
	                <TR CLASS="tablerbg">
	                    <TD ALIGN="CENTER"><xsl:value-of select="@name"/></TD>
	                    <TD>
	                    	<xsl:call-template name="component">
	                    		<xsl:with-param name="p" select="'P1'" />
	                    	</xsl:call-template>
	                    </TD>
	                    <TD>
	                    	<xsl:call-template name="component">
	                    		<xsl:with-param name="p" select="'P2'" />
	                    	</xsl:call-template>
	                    </TD>
	                    <TD>
	                    	<xsl:call-template name="component">
	                    		<xsl:with-param name="p" select="'P3'" />
	                    	</xsl:call-template>
	                    </TD>
	                    <TD>
	                    	<xsl:call-template name="component">
	                    		<xsl:with-param name="p" select="'P4'" />
	                    	</xsl:call-template>
	                    </TD>
	                    <TD>
	                    	<xsl:call-template name="component">
	                    		<xsl:with-param name="p" select="'P5'" />
	                    	</xsl:call-template>
	                    </TD>
	                </TR>
                </xsl:for-each>
                </TABLE>
            </TD>
        </TR>
        </TABLE>
    </P>
</html>
</xsl:template>


<xsl:template name="component">
	<xsl:param name="p" />
	<xsl:if test="count(issue[@priority=$p])=0">
            <xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
        </xsl:if>
	<xsl:for-each select="issue[@priority=$p]">
                <xsl:if test="time=/qbuild-report/@datestamp">
                    <a>
			<xsl:attribute name="href">&show_bug;?id=<xsl:value-of select="@id"/></xsl:attribute>
			<xsl:value-of select="@id" />
                    </a>
                    <xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
                </xsl:if>    
	</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
