/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.iz;

import org.apache.tools.ant.Task;
import org.apache.tools.ant.BuildException;

import org.netbeans.iz.IZQuery;

/**
 *
 * @author  jchalupa
 */
public class IZQueryTask extends Task {
    
    private IZQuery izqInstance;
    
    /** Creates a new instance of IZQueryTask */
    public IZQueryTask() {
        izqInstance = new IZQuery();
    }


    // ANT
    /**
     * Ant's execute method.
     */
     public void execute() throws BuildException {
        try {
            izqInstance.execute();
        }
        catch (Exception ex) {
            throw new BuildException(ex.getMessage(), ex);
        }
    }
    
    // ANT
    /**
     * Setter for ant taks query attribute
     *
     * @param filename name of xml query file
     */
    public void setQuery(String filename) {
        izqInstance.setQueryFile(filename);
    }

    // ANT
    /**
     * Setter for ant taks stoppers attribute
     *
     * @param id umbrella issue number with stoppers
     */
    public void setStoppersUmbrellaID(String id) {
        izqInstance.setStoppersUmbrellaID(id);
    }

    // ANT
    /**
     * Setter for ant taks stoppers attribute
     *
     * @param id umbrella issue number with stoppers
     */
    public void setFeatureStoppersUmbrellaID(String id) {
        izqInstance.setFeatureStoppersUmbrellaID(id);
    }
    
    // ANT
    /**
     * Setter for ant taks transform attribute
     *
     * @param filename name of XSL file
     */
    public void setTransform(String filename) {
        izqInstance.setTransformFile(filename);
    }
    
    // ANT
    /**
     * Setter for ant taks mergeTransform attribute
     *
     * @param filename name of XSL file
     */
    public void setMergeTransform(String filename) {
        izqInstance.setMergeTransformFile(filename);
    }

    // ANT
    /**
     * Setter for ant taks output attribute
     *
     * @param filename name of output file
     */
    public void setOutput(String filename) {
        izqInstance.setOutputFile(filename);
    }

    // ANT
    /**
     * Setter for proxy host.
     *
     * @param host proxy host.
     */
    public void setProxyhost(String host) {
        System.setProperty("http.proxyHost", host);
    }
    
    // ANT
    /**
     * Setter for proxy port.
     *
     * @param port proxy port.
     */
    public void setProxyport(String port) {
        System.setProperty("http.proxyPort", port);
    }

    // ANT
    /**
     * Setter for debug flag.
     *
     * @param arbitrary string (not used).
     */
    public void setDebug(String dummy) {
        izqInstance.setDebug(true);
    }
    
    
}
