/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.ui.dialogs;

import java.util.ArrayList;
import java.util.LinkedList;
import javax.swing.ComboBoxModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;

/**
 *
 * @author ehucka
 */
public class HistoryComboModel implements ComboBoxModel {
    String selected=null;
    
    ArrayList<ListDataListener> listeners=new ArrayList(4);
    LinkedList<String> list;
    
    public HistoryComboModel(LinkedList<String> list) {
        this.list = list;
    }
    
    public void setSelectedItem(Object anItem) {
        selected=(String)anItem;
    }
    
    public Object getElementAt(int index) {
        return list.get(index);
    }
    
    public void removeListDataListener(ListDataListener l) {
        listeners.remove(l);
    }
    
    public void addListDataListener(ListDataListener l) {
        if (!listeners.contains(l)) {
            listeners.add(l);
        }
    }
    
    public int getSize() {
        return list.size();
    }
    
    public Object getSelectedItem() {
        return selected;
    }
    
    public void intervalRemoved(ListDataEvent e) {
        for (int i = 0; i < listeners.size(); i++) {
            listeners.get(i).intervalRemoved(e);
        }
    }
    
    public void intervalAdded(ListDataEvent e) {
        for (int i = 0; i < listeners.size(); i++) {
            listeners.get(i).intervalAdded(e);
        }
    }
    
    public void contentsChanged(ListDataEvent e) {
        for (int i = 0; i < listeners.size(); i++) {
            listeners.get(i).contentsChanged(e);
        }
    }
    
    public void fireEventAddFirst() {
        intervalAdded(new ListDataEvent(this, ListDataEvent.INTERVAL_ADDED, 0, 0));
    }
    
    public void fireEventRemove(int index) {
        intervalAdded(new ListDataEvent(this, ListDataEvent.INTERVAL_ADDED, index, index));
    }
}
