---
--- Basic quiz statistics 
---
-- correct answers # group by category 
select d.name, count(*)
from response_item a, response b, quiz_question c, category d
where a.response = b.id
and b.quiz = c.quiz_id
and a.item_index = c.record
and a.is_correct = 1
and c.category = d.id
group by 1;

-- incorrect answers # group by category
select d.name, count(*)
from response_item a, response b, quiz_question c, category d
where a.response = b.id
and b.quiz = c.quiz_id
and a.item_index = c.record
and a.is_correct = 0
and c.category = d.id
group by 1;

-- e-mails of users who answered all questions correctly
select distinct(e.email)
from response_item a, response b, quiz_question c, category d, nbuser e
where a.response = b.id
and b.quiz = c.quiz_id
and a.item_index = c.record
and a.is_correct = 1
and c.category = d.id
and b.nbuser = e.id

-- dump all users who answered quiz #2
select nbuser.email
from response, nbuser
where response.quiz = 2
and response.nbuser = nbuser.id
into outfile "/tmp/quiz2.txt"
