<%-- 
  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 
  Copyright 1997-2008 Sun Microsystems, Inc. All rights reserved.
 
  The contents of this file are subject to the terms of either the GNU
  General Public License Version 2 only ("GPL") or the Common
  Development and Distribution License("CDDL") (collectively, the
  "License"). You may not use this file except in compliance with the
  License. You can obtain a copy of the License at
  http://www.netbeans.org/cddl-gplv2.html
  or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
  specific language governing permissions and limitations under the
  License.  When distributing the software, include this License Header
  Notice in each file and include the License file at
  nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
  particular file as subject to the "Classpath" exception as provided
  by Sun in the GPL Version 2 section of the License file that
  accompanied this code. If applicable, add the following below the
  License Header, with the fields enclosed by brackets [] replaced by
  your own identifying information:
  "Portions Copyrighted [year] [name of copyright owner]"
 
  Contributor(s):
 
  The Original Software is NetBeans. The Initial Developer of the Original
  Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
  Microsystems, Inc. All Rights Reserved.
 
  If you wish your version of this file to be governed by only the CDDL
  or only the GPL Version 2, indicate your decision by adding
  "[Contributor] elects to include this software in this distribution
  under the [CDDL or GPL Version 2] license." If you do not indicate a
  single choice of license, a recipient has the option to distribute
  your version of this file under either the CDDL, the GPL Version 2 or
  to extend the choice of license to its licensees as provided above.
  However, if you add GPL Version 2 code and therefore, elected the GPL
  Version 2 license, then the option applies only if the new code is
  made subject to such option by the copyright holder.
--%>
<%@page contentType="text/html" pageEncoding="UTF-8" isELIgnored="false"%>
<%@ page import="org.netbeans.modules.quiz.QuestionType" %>
<%@ page import="org.netbeans.modules.quiz.PersistenceUtils" %>
<%@ page import="org.netbeans.modules.quiz.entities.Category" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">

<%@include file="/WEB-INF/jspf/header.jspf" %>
<h2>NetBeans Quiz administration</h2>
<p>
    Date format is expected in this format:
            <%= java.text.DateFormat.getDateInstance().format(new java.util.Date()) %>
            <% pageContext.setAttribute("categories", PersistenceUtils.getAll(Category.class)); %>
</p>
<form action="processing" method="post">
    <table>
        <tr>
            <th>Quiz number:</th>
            <td>
                <input type="text" name="id" value="<%= org.netbeans.modules.quiz.entities.Quiz.suppressId()%>">
            </td>
        </tr>
        <tr>
            <th>Start date:</th>
            <td>
                <input type="text" name="startdate">
            </td>
        </tr>
        <tr>
            <th>End date:</th>
            <td>
                <input type="text" name="enddate">
            </td>
        </tr>
        <tr>
            <th>Prize:</th>
            <td>
                <input type="text" name="prize">
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <c:forEach begin="1" end="10" var="id">
                    <table style="border-width:medium;border-color:black;
                    border-top-style: solid; border-spacing:3px">
                        <tr>
                            <th>Question ${id}:</th>
                            <td>
                                <input type="text" name="question${id}">
                            </td>
                        </tr>
                        <tr>
                            <th>Category:</th>
                            <td>
                                <select name="category${id}">
                                    <c:forEach items="${categories}" var="category">
                                        <option value="${category.id}">${category.name}</option>
                                    </c:forEach>
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <th>Response type:</th>
                            <td>
                                <select name="response_type${id}">
                                    <%
                                for (QuestionType type: QuestionType.values()){
                                    %>
                                    <option value="<%= type.name()%>"><%= type.name()%></option>
                                    <% }%>
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <th>Response ${id}:</th>
                            <td>
                                <input type="text" name="response${id}">
                            </td>
                        </tr>
                    </table>
                </c:forEach>
            </td>
        </tr>
        <tr>
            <th>Page content:</th>
            <td>
                <textarea name="content" cols="100" rows="30" >
<!-- this code is going to be included into quiz page
don't change response names (every question input should use
following convention questionX X is number of question) and form parameters
you can add images and other html code where evere around
-->

    <!-- CHOICE TYPE
    <h4>1) First question</h4>
    <input name="question1" type="radio"  value="a">first response variant</input>
    <input name="question1" type="radio"  value="b">second response variant</input>
    <input name="question1" type="radio"  value="c">third response variant</input>
    -->
    
    <!-- WORD, SENTENCE TYPE
    <h4>2) Second question</h4>
    <input name="question2" type="text></input>
    <img src=""> Image
    -->
    
    <!--

     <pre>
       This is preformated code:
         main() {
         }
     </pre>
    -->
 <!--   prepared empty form:
 <h4>1) </h4>
<input name="question1" type="radio"  value="a"></input><br>
<input name="question1" type="radio"  value="b"></input><br>
<input name="question1" type="radio"  value="c"></input><br>
<input name="question1" type="radio"  value="d"></input>

<h4>2) </h4>
<input name="question2" type="radio"  value="a"></input><br>
<input name="question2" type="radio"  value="b"></input><br>
<input name="question2" type="radio"  value="c"></input><br>
<input name="question2" type="radio"  value="d"></input>

<h4>3) </h4>
<input name="question3" type="radio"  value="a"></input><br>
<input name="question3" type="radio"  value="b"></input><br>
<input name="question3" type="radio"  value="c"></input><br>
<input name="question3" type="radio"  value="d"></input>

<h4>4) </h4>
<input name="question4" type="radio"  value="a"></input><br>
<input name="question4" type="radio"  value="b"></input><br>
<input name="question4" type="radio"  value="c"></input><br>
<input name="question4" type="radio"  value="d"></input>
-->
                </textarea>
            </td>
        </tr>
        <tr>
            <td></td>
            <td>
                <input type="submit" name="submit" value="Submit">
            </td>
        </tr>
    </table>
</form>
<%@include file="/WEB-INF/jspf/footer.jspf" %>