<%-- 
  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 
  Copyright 1997-2008 Sun Microsystems, Inc. All rights reserved.
 
  The contents of this file are subject to the terms of either the GNU
  General Public License Version 2 only ("GPL") or the Common
  Development and Distribution License("CDDL") (collectively, the
  "License"). You may not use this file except in compliance with the
  License. You can obtain a copy of the License at
  http://www.netbeans.org/cddl-gplv2.html
  or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
  specific language governing permissions and limitations under the
  License.  When distributing the software, include this License Header
  Notice in each file and include the License file at
  nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
  particular file as subject to the "Classpath" exception as provided
  by Sun in the GPL Version 2 section of the License file that
  accompanied this code. If applicable, add the following below the
  License Header, with the fields enclosed by brackets [] replaced by
  your own identifying information:
  "Portions Copyrighted [year] [name of copyright owner]"
 
  Contributor(s):
 
  The Original Software is NetBeans. The Initial Developer of the Original
  Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
  Microsystems, Inc. All Rights Reserved.
 
  If you wish your version of this file to be governed by only the CDDL
  or only the GPL Version 2, indicate your decision by adding
  "[Contributor] elects to include this software in this distribution
  under the [CDDL or GPL Version 2] license." If you do not indicate a
  single choice of license, a recipient has the option to distribute
  your version of this file under either the CDDL, the GPL Version 2 or
  to extend the choice of license to its licensees as provided above.
  However, if you add GPL Version 2 code and therefore, elected the GPL
  Version 2 license, then the option applies only if the new code is
  made subject to such option by the copyright holder.
--%>
<%@page contentType="text/html" pageEncoding="UTF-8" isELIgnored="false"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ page import="org.netbeans.modules.quiz.AcceptingServlet" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<c:choose>
    <c:when test="${userid != null}">
        <html>
            <head>
                <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
                <title>NetBeans Quiz</title>
            </head>
            <body>
    </c:when>
    <c:otherwise>
        <%@ include file="WEB-INF/jspf/header.jspf" %>
    </c:otherwise>
</c:choose>
        <h2> Quiz number ${quizid} </h2>
        
        <c:choose>
            <c:when test="${userid != null}">
                <c:choose>
                    <c:when test="${missing_required}">
                        <p style="color:red">
                            You didn't fill all the required fields. Please fill the form completely.
                        </p>  
                    </c:when>
                    <c:when test="${missing_response}">
                        <p style="color:red">
                            You didn't response to all questions. Please fill the form completely.
                        </p>  
                    </c:when>
                    <c:when test="${incorrect_email}">
                        <p style="color:red">
                            You e-mail is not filled correctly. Please fill the form correctly.
                        </p>  
                    </c:when>
                    <c:otherwise>
                        <p>
                            Only individuals from countries listed in the 
                            <a href="http://www.netbeans.org/quiz/rules.html">rules</a> are allowed to enter this contest.
                        </p>  
                    </c:otherwise>
                </c:choose>
        
                <form action="accept" method="get">
                    <input type="hidden" name="userid" value="${userid}">
                    <input type="hidden" name="quizid" value="${quizid}">
                    <br>
                    ${formContent}
                    <br>
                    <hr>
                    <table>
                        <tr>
                            <th>Name*:</th><td><input type="text" name="username" value="${username}"></td>
                        </tr>
                        <tr>
                            <th>E-mail*:</th><td><input type="text" name="email" value="${email}"></td>
                        </tr>
                        <tr>
                            <th>University:</th><td><input type="text" name="university" value="${university}"></td>
                        </tr>
                        <tr>
                            <th>Country*:</th><td>
                                <select name="country" >
                                    <c:forEach items="${countries}" var="country">
                                        <option value="${country}">${country}</option>
                                    </c:forEach>
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td></td>
                            <td>
                                <c:choose>
                                    <c:when test="${notification}">
                                        <input type="checkbox" name="notification" checked="checked">
                                    </c:when>
                                    <c:otherwise>
                                        <input type="checkbox" name="notification">
                                        </c:otherwise>
                                    </c:choose>
                                    Send me new quiz e-mail notification
                                </input>
                            </td>
                        </tr>
                    </table>
                    <br>
                    <input type="submit" value="Submit" >
                </form>
                <p>
                    <small>* required fields</small>
                </p>
            </body>
        </html>
    </c:when>
    <c:otherwise>
        <br>
        ${formContent}
        <br>
        <%@ include file="WEB-INF/jspf/footer.jspf" %>
    </c:otherwise>
</c:choose>
