package org.netbeans.modules.regsup.auted;

import java.awt.*;
import java.awt.geom.*;
import javax.swing.Icon;

public class ContainerGeometry extends ConnectableGeometry {
    
    protected GeneralPath path;
    
    protected PointPlus[] snapPoints;
    
    protected VisualAutomatonContainer container;
    
    protected Color activeInColor = Color.pink;
    
    // !!!!! docasne
    static double BASE = 5;
    
    static double LONG_SIDE = 90;
    
    static double SHORT_SIZE = 24;
    // !!!!!
    
    private static final int HOR_SNAPS_COUNT = 15;
    
    private static final int VER_SNAPS_COUNT = 10;
    
    private static double WIDTH = 2 * BASE + LONG_SIDE;
    
    private static double HEIGHT = 2 * BASE + SHORT_SIZE;
    
    protected static final int SNAP_POINTS_COUNT = 2 * (HOR_SNAPS_COUNT + VER_SNAPS_COUNT);
    
    protected static final PointPlus[] relativeSnapPoints = new PointPlus [SNAP_POINTS_COUNT];
    
    static {
        prepareRelativeSnapPoints ();
    }
    
    /**
     */
    public ContainerGeometry (VisualAutomatonContainer container) {
        this.container = container;
        //
        float x = (float) container.position.getX ();
        float y = (float) container.position.getY ();
        path = new GeneralPath ();
        float a = x + (float) BASE;
        float aa = a + (float) LONG_SIDE;
        float aaa = aa + (float) BASE;
        float b = y + (float) BASE;
        float bb = b + (float) SHORT_SIZE;
        float bbb = bb + (float) BASE;
        // ! doesn't work - don't know why
        //shape = path.getBounds ();
        // complemental solution: but not neccessary
        //shape = new Rectangle2D.Double (x, y, WIDTH, HEIGHT);
        //
        snapPoints = new PointPlus [SNAP_POINTS_COUNT];
        for (int i = 0; i < snapPoints.length; i++) {
            snapPoints[i] = relativeSnapPoints[i].add (container.position);
            //System.out.println("i: " + i + " " + snapPoints[i]);
        }
        path.moveTo (a, y);
        path.lineTo (aa, y);
        path.lineTo (aaa, b);
        path.lineTo (aaa, bb);
        path.lineTo (aa, bbb);
        path.lineTo (a, bbb);
        path.lineTo (x, bb);
        path.lineTo (x, b);
        path.closePath ();
        //
        //activeColor = Color.PINK;
        shape = path;
    }
    
    private static void prepareRelativeSnapPoints () {
        double ELEM = LONG_SIDE / HOR_SNAPS_COUNT;
        double x = ELEM;
        // there were a lot of terrible bugs: indexes... :-( :o)
        // !! perf
        for (int i = 0; i < 2 * HOR_SNAPS_COUNT; i++) {
            relativeSnapPoints[i] = new PointPlus (x, 0);
            //System.out.println ("relative: " + relativeSnapPoints[i] + " in " + i);
            relativeSnapPoints[++i] = new PointPlus (x, HEIGHT);;
            //System.out.println ("relative: " + relativeSnapPoints[i] + " in " + i);
            x += ELEM;
        }
        ELEM = SHORT_SIZE / VER_SNAPS_COUNT;
        double y = ELEM;
        for (int i = 2 * HOR_SNAPS_COUNT; i < SNAP_POINTS_COUNT; i++) {
            relativeSnapPoints[i] = new PointPlus (0, y);
            //System.out.println ("relative: " + relativeSnapPoints[i] + " in " + i);
            relativeSnapPoints[++i] = new PointPlus (WIDTH, y);
            //System.out.println ("relative: " + relativeSnapPoints[i] + " in " + i);
            y += ELEM;
        }
    }
    
    /**
     */
    public void paint (Graphics2D g) {
        g.draw (path);
        //paintSnapPoints (snapPoints, g);
        Icon icon = container.getContentIcon ();
        int height = icon.getIconHeight ();
        int width = icon.getIconWidth ();
        int posX = (int) container.position.getX ();
        int posY = (int) container.position.getY ();
        int x = posX + 5; // ! const
        int y = posY + (int) (HEIGHT - height) / 2;
        icon.paintIcon (null, g, x, y);
        x = x + width + 4;
        int fontHeight = g.getFontMetrics ().getHeight ();
        g.drawString (container.getHumanName (), x, y + fontHeight - 4);
    }
    
    /**
     */
    void paintActiveIn (Graphics2D g) {
        Color oldColor = g.getColor ();
        g.setColor (activeInColor);
        g.fill (shape);
        g.setColor (oldColor);
        paint (g);
    }
    
    void paintActiveOut (Graphics2D g) {
    }
    
    /**
     */
    public boolean isOn (Point position) {
        return path.contains (position);
    }
    
    public boolean isOnForSelection (Point position) {
        return isOn (position);
    }
    
    public int getConnectPolicy () {
        return ConnectableGeometry.CONNECT_POLICY_SNAPS;
    }
    
    public Point[] getSnapPoints () {
        // !!!??? radsi klonovat
        return snapPoints;
    }
    
}

