/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 *
 * @author  Petr Slegr
 * @version 27.03.02
 */
public class GeneratePanel extends javax.swing.JPanel {

    /** Creates new form GeneratePanel */
    public GeneratePanel () {
        initComponents();
        generateDFAButton.addActionListener (new DFAActionListener ());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        generateNFAButton = new javax.swing.JButton();
        generateDFAButton = new javax.swing.JButton();
        expressionLabel = new javax.swing.JLabel();
        expressionTextField = new javax.swing.JTextField();

        setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new java.awt.GridBagLayout());

        generateNFAButton.setText("Generate NFA");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        jPanel1.add(generateNFAButton, gridBagConstraints);

        generateDFAButton.setText("Generate DFA");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        jPanel1.add(generateDFAButton, gridBagConstraints);

        expressionLabel.setText("Expression");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        jPanel1.add(expressionLabel, gridBagConstraints);

        expressionTextField.setMinimumSize(new java.awt.Dimension(300, 21));
        expressionTextField.setPreferredSize(new java.awt.Dimension(300, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        jPanel1.add(expressionTextField, gridBagConstraints);

        add(jPanel1, java.awt.BorderLayout.NORTH);

    }//GEN-END:initComponents

    /** Registers ActionListener to receive events.
     * @param listener The listener to register.
     */
    synchronized void addDFAActionListener (java.awt.event.ActionListener listener) throws java.util.TooManyListenersException {
        if (dfaActionListener != null) {
            throw new java.util.TooManyListenersException ();
        }
        dfaActionListener = listener;
    }    

    /** Removes ActionListener from the list of listeners.
     * @param listener The listener to remove.
     */
    synchronized void removeDFAActionListener (java.awt.event.ActionListener listener) {
        dfaActionListener = null;
    }    
    
    /** Notifies the registered listener about the event.
     *
     * @param event The event to be fired
     */
    private void fireDFAActionPerformed (java.awt.event.ActionEvent event) {
        if (dfaActionListener == null) return;
        dfaActionListener.actionPerformed (event);
    }

    private void fireNFAActionPerformed (java.awt.event.ActionEvent event) {
        if (nfaActionListener == null) return;
        nfaActionListener.actionPerformed (event);
    }

    /** Registers ActionListener to receive events.
     * @param listener The listener to register.
     */
    synchronized void addNFAActionListener (java.awt.event.ActionListener listener) throws java.util.TooManyListenersException {
        if (nfaActionListener != null) {
            throw new java.util.TooManyListenersException ();
        }
        nfaActionListener = listener;
    }
    
    /** Removes ActionListener from the list of listeners.
     * @param listener The listener to remove.
     */
    synchronized void removeNFAActionListener (java.awt.event.ActionListener listener) {
        nfaActionListener = null;
    }
    
    /**
     */
    String getExpressionString () {
        return expressionTextField.getText ();
    }
    
    void setExpressionString (String str) {
        expressionTextField.setText (str);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel expressionLabel;
    private javax.swing.JButton generateDFAButton;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTextField expressionTextField;
    private javax.swing.JButton generateNFAButton;
    // End of variables declaration//GEN-END:variables

    /** Utility field holding the ActionListener. */
    private transient java.awt.event.ActionListener dfaActionListener =  null;    

    /** Utility field holding the ActionListener. */
    private transient java.awt.event.ActionListener nfaActionListener =  null;
    
    private class DFAActionListener implements ActionListener {
        
        public void actionPerformed (java.awt.event.ActionEvent event) {
            fireDFAActionPerformed (event);
        }
        
    }
}
