/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted.actions;

import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;
import org.netbeans.modules.regsup.auted.MainManager;

/** Action that can always be invoked and work procedurally.
 *
 * @author  Petr Slegr
 * @version 04.11.01
 */
public class RedoAction extends CallableSystemAction {

    protected RedoAction () {
        super ();
    }

    public void performAction () {
        MainManager.getDefault ().getCurrentEditor ().getUndoManager ().redo ();
    }

    public String getName () {
        if (! isEnabled ()) {
            return "Redo";  // !! bundle
        } else {
            return MainManager.getDefault ().getCurrentEditor ().getUndoManager ().
            getRedoPresentationName ();
        }
    }

    protected String iconResource () {
        return "ActionIcon.gif";
    }

    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (AddNodeActionAction.class);
    }

    /** Test whether the action is currently enabled.
     * @return <code>true</code> if so
     */
    public boolean isEnabled () {
        return MainManager.getDefault ().getCurrentEditor ().getUndoManager ().
        canRedo ();
    }
    
    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
    protected void initialize () {
	super.initialize ();
     * putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (AddNodeActionAction.class, "HINT_Action"));
    }
    */

}
