/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted.actions;

import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;
import org.netbeans.modules.regsup.auted.*;
import org.netbeans.modules.regsup.logic.*;
import java.awt.Point;
import org.netbeans.modules.regsup.debug.*;
import org.netbeans.modules.regsup.util.Util;

/**
 *
 * @author  Petr Slegr
 * @version 01.04.02
 */
public class ToggleBreakpointAction extends ElementAction implements DebuggingAction {


    public void performAction (VisualAutomatonElement[] selected) {
        VisualAutomatonContainer root = selected[0].getRootContainer ();
        for (int i = 0; i < selected.length; i++) {
            RexBreakpoint breakpoint = new NodeBreakpoint ((VisualAutomatonNode) selected[i]);
            RexDebugger.addBreakpoint (root, breakpoint);
        }
    } 

    public String getName () {
        return "Toggle Breakpoint";
    }

    protected String iconResource () {
        return "ActionIcon.gif";
    }

    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (AddNodeActionAction.class);
    }

    /** 
     * @return true iff one VisualAutomatonNode is selected
     */
    public boolean isEnabled (VisualAutomatonElement[] selected) {
        boolean b1 = Util.areAllInstanceOf (selected, VisualAutomatonNode.class);
        boolean b2 = selected.length > 0;
        return b1 && b2;
        /*
        if (selected.length != 1) {
            return false;
        }
        if (! (selected[0] instanceof VisualAutomatonNode)) {
            return false;
        }
        return true;
         */
        //return false;
    }
    
    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
    protected void initialize () {
	super.initialize ();
     * putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (AddNodeActionAction.class, "HINT_Action"));
    }
    */

}
