/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.ide;

import org.openide.actions.*;
import org.openide.cookies.*;
import org.openide.filesystems.FileObject;
import org.openide.loaders.*;
import org.openide.nodes.*;
import org.openide.util.HelpCtx;

/** Represents a Regsup object in the Repository.
 *
 * @author Petr Slegr
 * @version 01.05.02
 */
public class RegsupDataObject extends MultiDataObject {
    
    public RegsupDataObject (FileObject pf, RegsupDataLoader loader) throws DataObjectExistsException {
        super (pf, loader);
        init ();
    }
    
    private void init () {
        CookieSet cookies = getCookieSet ();
        cookies.add (new RegsupOpenSupport (this));
        /*
        cookies.add (new ExecSupport (getPrimaryEntry ()));
        // See Editor Support template in Editor API:
        cookies.add (new RegsupEditorSupport (this));
        cookies.add (new CompilerSupport.Compile (getPrimaryEntry ()));
        cookies.add (new CompilerSupport.Build (getPrimaryEntry ()));
        cookies.add (new CompilerSupport.Clean (getPrimaryEntry ()));
        cookies.add (new OpenCookie () {
                public void open () {
                    // do something...but usually you want to use OpenSupport instead
                }
            });
         */
    }
    
    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
        // If you add context help, change to:
        // return new HelpCtx (RegsupDataObject.class);
    }
    
    protected Node createNodeDelegate () {
        return new RegsupDataNode (this);
    }
    
    final void addSaveCookie (SaveCookie save) {
        getCookieSet ().add (save);
    }
     
    final void removeSaveCookie (SaveCookie save) {
        getCookieSet ().remove (save);
    }
    
}
