/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.ide;

import org.openide.modules.ModuleInstall;
import org.netbeans.modules.regsup.auted.MainManager;

/** Manages a module's lifecycle.
 * Remember that an installer is optional and often not needed at all.
 *
 * @author Petr Slegr
 * @version 29.04.02
 */
public class RegsupInstaller extends ModuleInstall {
    
    // By default, do nothing but call restored ().
    /*
    public void installed () {
        restored ();
    }
     */
    
    public void restored () {
        MainManager.getDefault ().setRunMode (MainManager.RUN_IDE);
        /*
        try {
        Class clazz = Class.forName ("org.netbeans.modules.regsup.auted.EdgeValueDialog");
        System.out.println("clazz: " + clazz);
        System.out.println("source: " + clazz.getProtectionDomain ().getCodeSource ());
        }
        catch (Exception e) {
            e.printStackTrace();
        }
         */
    }
    
    // By default, do nothing.
    /*
    public void uninstalled () {
    }
     */
    
    // By default, call restored ().
    /*
    public void updated (int release, String specVersion) {
    }
     */
    
    // It is no longer recommended to override Externalizable methods
    // (readExternal and writeExternal). See the Modules API section on
    // "installation-clean" modules for an explanation.
    
}
