/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.logic;

/** This class represents edge element with inner structure obtained by some
 * parser (e.g. Regexp) but the presentation form is equal to the one from user input.
 *
 * @author  Petr Slegr
 */
public class ParsedEdgeElement extends ComplexRexEdgeElement {
    
    private String display;
    
    /** Creates a new instance of ParsedEdgeElement
     * @param display presentation form of element
     */
    public ParsedEdgeElement (String display) {
        super (false);
        this.display = display;
    }
    
    public String toString () {
        return display;
    }
    
}
