/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.logic.aut2expr;

import org.netbeans.modules.regsup.logic.*;
import java.util.ArrayList;

/**
 *
 * @author  Petr Slegr
 * @version 02.12.01 
 */
public class DirectResolveError extends DirectResolveProblem {

    /** Creates global error
     */
    public DirectResolveError (String problemName) {
        super (problemName, true);
    }
    
    /** Creates local error
     */
    public DirectResolveError (String problemName, LogicAutomatonNode cause) {
        super (problemName, cause, true);
    }

    // following problems are global
    
    ////////////////////////////////////////////////////////////////////////////
    public static class MissingStartingNode extends DirectResolveError {
        
        public MissingStartingNode () {
            super ("Missing starting node");
        }
    }
    
    public static class MissingFinalNode extends DirectResolveError {
        
        public MissingFinalNode () {
            super ("Missing final node");
        }
    }
    
    // !!!! u NFA neni vic startovnich nodu problem, ale musel by se trochu predelat debugger
    public static class TooManyStartingNodes extends DirectResolveError {
        
        public TooManyStartingNodes () {
            super ("Too many of starting nodes");
        }
    }
    
   /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
    }

}
