/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.modules.vcs.cmdline;

import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.JFrame;
import java.util.*;

import org.openide.*;
import org.openide.util.*;

import org.netbeans.modules.vcscore.util.*;

/** The first panel in the wizard.
 * Lets the user fill  out cvs exe command location, current working directory and refresh period.
 *
 * @author mkleint
 * @version 1.0
 */
public class Cust1WorkPanel extends javax.swing.JPanel implements CvsCustomPanel {
    private ArrayList listeners;
    
    private Cust1WorkPanel pan;
    private CvsFileSystem fs;

    static final long serialVersionUID = -3105432801845332865L;

    /** Creates the panel.
     */
    public Cust1WorkPanel() {
        initComponents ();
        pan = this;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        lbWorking = new javax.swing.JLabel();
        txWorking = new javax.swing.JTextField();
        btnWorking = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        lbCvsExe = new javax.swing.JLabel();
        txCvsExe = new javax.swing.JTextField();
        btnCvsExe = new javax.swing.JButton();
        cbUseUnix = new javax.swing.JCheckBox();
        lbShell = new javax.swing.JLabel();
        txShell = new javax.swing.JTextField();
        btnShell = new javax.swing.JButton();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        setDebugGraphicsOptions(javax.swing.DebugGraphics.NONE_OPTION);
        
        lbWorking.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("NewCvsCustomizer.lbWorking.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 5, 5);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lbWorking, gridBagConstraints1);
        
        
        txWorking.setColumns(20);
        txWorking.setDebugGraphicsOptions(javax.swing.DebugGraphics.NONE_OPTION);
        txWorking.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                txWorkingFocusLost(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(12, 7, 5, 5);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        add(txWorking, gridBagConstraints1);
        
        
        btnWorking.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("NewCvsCustomizer.btnWorking.label"));
        btnWorking.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnWorkingActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(12, 0, 5, 11);
        add(btnWorking, gridBagConstraints1);
        
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        jPanel1.setBorder(new javax.swing.border.EtchedBorder());
        
        lbCvsExe.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("NewCvsCustomizer.lbCvsExe.text"));
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 0;
          gridBagConstraints2.insets = new java.awt.Insets(12, 12, 0, 5);
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          jPanel1.add(lbCvsExe, gridBagConstraints2);
          
          
        txCvsExe.setColumns(20);
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 1;
          gridBagConstraints2.gridy = 0;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.insets = new java.awt.Insets(12, 7, 0, 5);
          gridBagConstraints2.weightx = 1.0;
          jPanel1.add(txCvsExe, gridBagConstraints2);
          
          
        btnCvsExe.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("NewCvsCustomizer.btnCvsExe.label"));
          btnCvsExe.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  btnCvsExeActionPerformed(evt);
              }
          }
          );
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 2;
          gridBagConstraints2.gridy = 0;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.insets = new java.awt.Insets(12, 0, 0, 11);
          jPanel1.add(btnCvsExe, gridBagConstraints2);
          
          
        cbUseUnix.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("NewCvsCustomizer.cbUseUnix.label"));
          cbUseUnix.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  cbUseUnixActionPerformed(evt);
              }
          }
          );
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 1;
          gridBagConstraints2.gridwidth = 3;
          gridBagConstraints2.insets = new java.awt.Insets(5, 12, 0, 11);
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          jPanel1.add(cbUseUnix, gridBagConstraints2);
          
          
        lbShell.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("NewCvsCustomizer.lbShell.text"));
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 2;
          gridBagConstraints2.insets = new java.awt.Insets(5, 18, 11, 5);
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          jPanel1.add(lbShell, gridBagConstraints2);
          
          
        txShell.setColumns(20);
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 1;
          gridBagConstraints2.gridy = 2;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.insets = new java.awt.Insets(5, 7, 11, 5);
          gridBagConstraints2.weightx = 1.0;
          jPanel1.add(txShell, gridBagConstraints2);
          
          
        btnShell.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("NewCvsCustomizer.btnShell.label"));
          btnShell.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  btnShellActionPerformed(evt);
              }
          }
          );
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 2;
          gridBagConstraints2.gridy = 2;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.insets = new java.awt.Insets(5, 0, 11, 11);
          jPanel1.add(btnShell, gridBagConstraints2);
          
          
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 11, 11);
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(jPanel1, gridBagConstraints1);
        
    }//GEN-END:initComponents

  private void cbUseUnixActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbUseUnixActionPerformed
// Add your handling code here:
      useUnixState();
  }//GEN-LAST:event_cbUseUnixActionPerformed

  private void btnShellActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnShellActionPerformed
        ChooseFileDialog chooseFile=new ChooseFileDialog(new JFrame(), new File(txShell.getText ()), false);
        VcsUtilities.centerWindow (chooseFile);
        HelpCtx.setHelpIDString (chooseFile.getRootPane (), NewCvsCustomizer.class.getName ());
        chooseFile.show();
        String selected=chooseFile.getSelectedFile();
        if( selected==null ){
            //D.deb("no directory selected"); // NOI18N
            return ;
        }
        txShell.setText (selected);
        //fileSystem.setCygwinPath (selected);
      
  }//GEN-LAST:event_btnShellActionPerformed

  private void btnCvsExeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCvsExeActionPerformed
        ChooseFileDialog chooseFile=new ChooseFileDialog(new JFrame(), new File(txCvsExe.getText ()), false);
        VcsUtilities.centerWindow (chooseFile);
        HelpCtx.setHelpIDString (chooseFile.getRootPane (), NewCvsCustomizer.class.getName ());
        chooseFile.show();
        String selected=chooseFile.getSelectedFile();
        if( selected==null ){
            //D.deb("no directory selected"); // NOI18N
            return ;
        }
        txCvsExe.setText (selected);
  }//GEN-LAST:event_btnCvsExeActionPerformed

  private void btnWorkingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnWorkingActionPerformed
// Add your handling code here:
        ChooseDirDialog chooseDir=new ChooseDirDialog(new JFrame(), new File(txWorking.getText ()));
        VcsUtilities.centerWindow (chooseDir);
        HelpCtx.setHelpIDString (chooseDir.getRootPane (), NewCvsCustomizer.class.getName ());
        chooseDir.show();
        String selected=chooseDir.getSelectedDir();
        if( selected==null ){
            //D.deb("no directory selected"); // NOI18N
            return ;
        }
        txWorking.setText(selected);
        fireChangeState();
      
  }//GEN-LAST:event_btnWorkingActionPerformed

  private void txWorkingFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txWorkingFocusLost
// Add your handling code here:
      fireChangeState();
  }//GEN-LAST:event_txWorkingFocusLost


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel lbWorking;
  private javax.swing.JTextField txWorking;
  private javax.swing.JButton btnWorking;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JLabel lbCvsExe;
  private javax.swing.JTextField txCvsExe;
  private javax.swing.JButton btnCvsExe;
  private javax.swing.JCheckBox cbUseUnix;
  private javax.swing.JLabel lbShell;
  private javax.swing.JTextField txShell;
  private javax.swing.JButton btnShell;
  // End of variables declaration//GEN-END:variables

    
    public void setWorking(String work) {
      txWorking.setText(work);  
    }    

    public void setCvsExe(String exe) {
      txCvsExe.setText(exe);  
    }    
    
    public void setShell(String shell) {
      txShell.setText(shell);  
    }    

    public void setUseUnix(boolean use) {
        cbUseUnix.setSelected(use);
    }    

    public String getWorking() {
      return txWorking.getText();  
    }    

    public String getCvsExe() {
      return txCvsExe.getText();  
    }    
    
    public String getShell() {
      return txShell.getText();  
    }    

    
    public boolean getUseUnix() {
       return cbUseUnix.isSelected();
    }    
    
    
    
/** name of the panel.
 * @return the name of the current panel.
 */
    public String getName() {
      return org.openide.util.NbBundle.getBundle(NewCvsCustomizer.class).getString("NewCvsCustomizer.workDialogLabel");        
    }
    
    
/** last panel check.
 * @return true if last else false.
 */
    public boolean isLast() {
        return false;
    }
    
    
/** if the working directory does not exist or is not directory, then notifies the user and returns the current panel number. (Thus remains in the panel untill it's filled correctly).
 * If working dir is empty returns the number of Cust2ServerPanel
 * Else the Cust4RelMountPanel is returned.
 * @return the number of next panel.
 */
    public int getNext() {
    //    return new Cust2ServerPanel();    
        File dir = new File(pan.getWorking());
        if (!dir.exists()) {
            javax.swing.SwingUtilities.invokeLater(new Runnable () {
                public void run () {
                        TopManager.getDefault ().notify (new NotifyDescriptor.Message(org.openide.util.NbBundle.getBundle(CvsCustomizer.class).getString("NewCvsCustomizer.dirNotExists")));
                }
            });
            return 1; 
        }
        if (!dir.isDirectory()) {
            javax.swing.SwingUtilities.invokeLater(new Runnable () {
                public void run () {
                        TopManager.getDefault ().notify (new NotifyDescriptor.Message(org.openide.util.NbBundle.getBundle(CvsCustomizer.class).getString("NewCvsCustomizer.notDirectory")));
                }
            });
            return 1; 
        }
        if (getUseUnix()) {
            File sh = new File(getShell());
            if (!sh.exists()) {
                javax.swing.SwingUtilities.invokeLater(new Runnable () {
                    public void run () {
                        TopManager.getDefault ().notify (new NotifyDescriptor.Message(org.openide.util.NbBundle.getBundle(CvsCustomizer.class).getString("NewCvsCustomizer.wrongShellPath")));
                    }
                });
                return 1;
            }
        }

        if (fs.isCheckoutNeeded(new File(pan.getWorking()))) {
          return 2;
        } else {
          return 4;    
        }        

    }


    /** Add a listener to changes of the panel's validity.
     * @param l the listener to add
     * @see #isValid
     */
    public synchronized void addChangeListener(ChangeListener l) {
        if (listeners == null) {
            listeners = new ArrayList ();
        }
        listeners.add (l);        
    }
    /** Remove a listener to changes of the panel's validity.
     * @param l the listener to remove
     */
    public synchronized void removeChangeListener(ChangeListener l) {
        if (listeners != null) {
            listeners.remove (l);
        }
    }
    
    private void fireChangeState() {
        ArrayList list;
        synchronized (this) {
            if (this.listeners == null)
                return;
            list = (ArrayList) this.listeners.clone();
        }
        ChangeEvent event = new ChangeEvent (this);
        for (int i=0; i<list.size(); i++)
            ((ChangeListener)list.get (i)).stateChanged (event);
    }    
    
    private void useUnixState() {
      boolean enable = this.cbUseUnix.isSelected();
      txShell.setEnabled(enable);
      btnShell.setEnabled(enable);
      lbShell.setEnabled(enable);
    }    
    
    private void updateEnabled() {
        //String osName = System.getProperty("os.name");
        if(org.openide.util.Utilities.isWindows()) { // NOI18N
            cbUseUnix.setEnabled (true);
            int os = org.openide.util.Utilities.getOperatingSystem();
            if (os == org.openide.util.Utilities.OS_WIN95 ||
                os == org.openide.util.Utilities.OS_WIN98) {
                    cbUseUnix.setSelected(true);
                    useUnixState();
            }
        } else {
            cbUseUnix.setVisible (false);
            btnShell.setVisible(false);
            lbShell.setVisible(false);
            txShell.setVisible(false);
            cbUseUnix.setSelected(false);
        }   
    }


    public static class Panel implements WizardDescriptor.Panel {

        private Cust1WorkPanel panel;
        private String name;


        public Panel (String name) {
            this.name = name;
        }

        /** Get the component displayed in this panel.
         * @return the component
         */
        public synchronized java.awt.Component getComponent() {
            if (this.panel == null) {
                this.panel = new Cust1WorkPanel();
                if (this.name != null)
                    this.panel.setName (this.name);
            }
            return this.panel;

        }
        /** Help for this panel.
         * When the panel is active, this is used as the help for the wizard dialog.
         * @return the help or <code>null</code> if no help is supplied
         */
        public HelpCtx getHelp() {
            return HelpCtx.DEFAULT_HELP;
        }
        /** Provides the wizard panel with the current data--either
         * the default data or already-modified settings, if the user used the previous and/or next buttons.
         * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
         * @param settings the object representing wizard panel state, as originally supplied to {@link WizardDescriptor#WizardDescriptor(WizardDescriptor.Iterator,Object)}
         */
        public void readSettings(Object settings) {
            if (settings instanceof NewCvsCustomizer) {
                NewCvsCustomizer customizer = (NewCvsCustomizer)settings;
                Cust1WorkPanel p = (Cust1WorkPanel) this.getComponent();
                p.fs = customizer.getFileSystem();
                p.pan.setWorking(customizer.rootDir);
                p.pan.setCvsExe(customizer.cvsExe);
                p.pan.setUseUnix(customizer.useUnixShell);
                p.pan.setShell(customizer.cygwinPath);
//        pan.setRefresh(customizer.refresh);
                p.updateEnabled();
                p.useUnixState();
            }
        }
        /** Provides the wizard panel with the opportunity to update the
         * settings with its current customized state.
         * Rather than updating its settings with every change in the GUI, it should collect them,
         * and then only save them when requested to by this method.
         * Also, the original settings passed to {@link #readSettings} should not be modified (mutated);
         * rather, the (copy) passed in here should be mutated according to the collected changes.
         * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
         * @param settings the object representing a settings of the wizard
         */
        public void storeSettings(Object settings) {
            if (settings instanceof NewCvsCustomizer) {
                NewCvsCustomizer customizer = (NewCvsCustomizer)settings;
                Cust1WorkPanel p = (Cust1WorkPanel) this.getComponent();
                if (!customizer.rootDir.equals(p.pan.getWorking())) {
                    customizer.relMount = "";
                }
                customizer.rootDir = p.pan.getWorking();
                customizer.cvsExe = p.pan.getCvsExe();
                customizer.useUnixShell = p.pan.getUseUnix();
                customizer.cygwinPath = p.pan.getShell();
//        customizer.refresh = pan.getRefresh();
                customizer.setWait(false); // only after checkout in Cust3Checkout -> wait is true
            }
        }

        /** Test whether the panel is finished and it is safe to proceed to the next one.
         * If the panel is valid, the "Next" (or "Finish") button will be enabled.
         * @return <code>true</code> if the user has entered satisfactory information
         */
        public boolean isValid() {
            Cust1WorkPanel p = (Cust1WorkPanel) this.getComponent();
            if (p.pan.getWorking().equals("")) return false;
            return true;
        }

        public void addChangeListener (ChangeListener l) {
            Cust1WorkPanel p = (Cust1WorkPanel) this.getComponent();
            p.addChangeListener (l);
        }

        public void removeChangeListener (ChangeListener l) {
            Cust1WorkPanel p = (Cust1WorkPanel) this.getComponent();
            p.removeChangeListener (l);
        }

    }

}